// AVIViewDlg.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "AVIViewDlg.h"

#define fourcc(a,b,c,d)\
	(((unsigned)(a)<<0)|((unsigned)(b)<<8)|((unsigned)(c)<<16)|((unsigned)(d)<<24))

typedef struct _RIFF_LIST {
	DWORD	dwList;
	DWORD	dwSize;
	DWORD	dwFourCC;
	//BYTE	data[dwSize-4];  // Xg`Ni[
} RIFF_LIST;



// CAVIViewDlg _CAO

IMPLEMENT_DYNAMIC(CAVIViewDlg, CDialog)

CAVIViewDlg::CAVIViewDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAVIViewDlg::IDD, pParent)
{

}

CAVIViewDlg::~CAVIViewDlg()
{
}

void CAVIViewDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_VIEW, m_xcEditView);
}


BEGIN_MESSAGE_MAP(CAVIViewDlg, CDialog)
END_MESSAGE_MAP()




void CAVIViewDlg::FourCCToString(DWORD dwFourCC, std::wstring &wsOutput)
{
	unsigned char chFourCC[5];
	chFourCC[0] = (unsigned char)((dwFourCC & 0x000000FF));
	chFourCC[1] = (unsigned char)((dwFourCC & 0x0000FF00) >> 8);
	chFourCC[2] = (unsigned char)((dwFourCC & 0x00FF0000) >> 16);
	chFourCC[3] = (unsigned char)((dwFourCC & 0xFF000000) >> 24);
	chFourCC[4] = '\0';

	CString csTmp;
	csTmp.Format(L"%S", chFourCC);
	wsOutput = csTmp;
}


// CAVIViewDlg bZ[W nh

BOOL CAVIViewDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	FILE *pFile = NULL;

	if (::_wfopen_s(&pFile, L"E:\\test.avi", L"rb"))
	{
		return TRUE;
	}

	::rewind(pFile);

	RIFF_LIST list;
	std::wstring wsLIST;

	::fread(&list, sizeof(RIFF_LIST), 1, pFile);

	FourCCToString(list.dwFourCC, wsLIST);

	m_xcEditView.SetWindowText(wsLIST.c_str());


	::fclose(pFile);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}
