#pragma once
#include "afxwin.h"


// CEVRProcAmpPage _CAO

class CEVRProcAmpPage : public CPropertyPage
{
	DECLARE_DYNAMIC(CEVRProcAmpPage)

public:
	CEVRProcAmpPage(CMainDlg *dlg, CCaptureGraphProfile *profile);
	virtual ~CEVRProcAmpPage();

// _CAO f[^
	enum { IDD = IDD_EVR_PROC_AMP };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()

private:
	CMainDlg* const dlg_;
	CCaptureGraphProfile* const profile_;

private:
	CCaptureGraphBuilder* const graph_; // Otr_[
	CEVRProcAmpConfig* const cfg_; // ݒl

	CEVRProcAmpRanges range_; // ݒ͈͂ƋKl

	bool isinit_; // _CAOꂽ

	void SetControlParam(int index, int val);

public:
	CScrollBar m_xcScrollBar[4];
	CEdit m_xcEdit[4];
	CButton m_xcButton[4];
	CButton m_xcBtnDefault;

	virtual BOOL OnInitDialog();
	virtual void OnOK();

	void InitCtrl();

	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedButton1();
	afx_msg void OnBnClickedButton2();
	afx_msg void OnBnClickedButton3();
	afx_msg void OnBnClickedButton4();
	afx_msg void OnBnClickedBtnDefault();
};
