// MainDlg.h : wb_[ t@C
//

#pragma once



// j[̃vt@CID͈̔
#define IDM_PROFILE_RANGE_START		50000
#define IDM_PROFILE_RANGE_END		50099

// j[̃tB^Ot͈̔
#define IDM_FILTERGRAPH_RANGE_START	50100
#define IDM_FILTERGRAPH_RANGE_END	50199

// j[̉fTCY͈̔
#define IDM_WINDOWSIZE_RANGE_START	50200
#define IDM_WINDOWSIZE_RANGE_END	50299

// j[̉fg嗦͈̔
#define IDM_WINDOWZOOM_RANGE_START	50300
#define IDM_WINDOWZOOM_RANGE_END	50399

#define TIMER_ID_CAPTION			0
#define TIMER_ID_MOUSE_HIDE			1


typedef enum _FRAMEPOS {
	FRAMEPOS_NONE = -1,
	FRAMEPOS_TOP = 0,
	FRAMEPOS_TOPLEFT,
	FRAMEPOS_TOPRIGHT,
	FRAMEPOS_LEFT,
	FRAMEPOS_RIGHT,
	FRAMEPOS_BOTTOM,
	FRAMEPOS_BOTTOMLEFT,
	FRAMEPOS_BOTTOMRIGHT,
};



// CMainDlg _CAO
class CMainDlg : public CDialog
{
// RXgNV
public:
	CMainDlg(CWnd* pParent = NULL);	// WRXgN^

// _CAO f[^
	enum { IDD = IDD_MAIN };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g


// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

private:
	CCaptureGraphProfile profile_; // Jgvt@C


public:

	BOOL m_bFullScreen;
	BOOL ToggleFullScreen(void);	// tXN[
	WINDOWPLACEMENT m_stWndRestore;	// tXN[ÕEBhEʒu


	CCaptureGraphBuilder m_Preview;				// Lv`[

	BOOL SetProcessPriority(long lPriority);	// vZXDxݒ

	void OnPreviewIsRunBuild(); // ĐȂč\z

	void ChangeCaption(void); // ^Cgo[Caption
	void StartCaptionTimer(void);
	void EndCaptionTimer(void);
	void StartMouseHideTimer(void);
	void EndMouseHideTimer(void);

	std::wstring m_wsStatus[5];

	void ResizeWindow(); // OnSizeȂǃEBhẼTCYύXɌĂ

	int GetFramePos(CPoint &pt); // [TCYύXg̈ʒuiNCAgWj

	BOOL m_bWindowDragFlag; // EBhEhbOtO OnLBottonDown,Up ŃIIt OnMouseMoveňړ
	CPoint m_ptWindowDrag; // EBhEhbOɎgEBhEɑ΂}EẌʒu

	std::vector<WindowSize> m_vecWindowSize; // j[EfTCY\p
	std::vector<WindowZoom> m_vecWindowZoom; // j[Efg嗦\p


	BOOL SetWindowSize(int nWidth, int nHeight);
	BOOL SetWindowSizeZoom(double dZoom); // EBhEg嗦
	BOOL ConvertWindowRect(LPRECT lpRect); // EBhEX^Cɍ킹EBhETCYԂ
	BOOL NoMoveApplyWindowAspectRatioSize(void); // ݂̈ʒuÂ܂܃EBhEAXyNgKp

	BOOL SetTransformCopy(long lTransformCopy); // fC^[[XύX
	BOOL SetTransformFrame(long lTransformFrame); // t[[gύX
	BOOL SetTransformFieldOrder(long lTransformFieldOrder); // tB[hI[_[ύX

	void ShowInnerFilterDlg(int tab); // tB^_CAO\

	void SetAudioVolume(int volume);
	void SetAudioVolumeDelta(int volume);

public:
	afx_msg void OnDestroy();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnDebug01();
	afx_msg void OnDebug02();
	LRESULT OnGraphNotify(WPARAM wParam, LPARAM lParam);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRegisterProfile();
	afx_msg void OnSelectProfile(UINT nID);
	afx_msg void OnSelectFilterGraph(UINT nID);
	afx_msg void OnTransform();
	afx_msg void OnTransformCopyNone();
	afx_msg void OnTransformCopySimple();
	afx_msg void OnTransformCopyLiner();
	afx_msg void OnTransformCopyLinerSharp();
	afx_msg void OnTransformCopyBlend();
	afx_msg void OnTransformCopyBlendSharp();
	afx_msg void OnTransformCopyHardware();
	afx_msg void OnTransformFrameNone();
	afx_msg void OnTransformFrameHalf();
	afx_msg void OnTransformFrameDouble();
	afx_msg void OnTransformFieldOrderOdd();
	afx_msg void OnTransformFieldOrderEven();
	afx_msg void OnTransformYcexpandNone();
	afx_msg void OnTransformYcexpandUyvy();
	afx_msg void OnTransformYcexpandYuv2();
	afx_msg void OnTransformFlipVertical();
	afx_msg void OnPreviewRun();
	afx_msg void OnPreviewStop();
	afx_msg void OnPreviewBuild();
	afx_msg void OnProcessPriorityRealtime();
	afx_msg void OnProcessPriorityHigh();
	afx_msg void OnProcessPriorityAboveNormal();
	afx_msg void OnProcessPriorityNormal();
	afx_msg void OnProcessPriorityBelowNomal();
	afx_msg void OnProcessPriorityIdle();
	afx_msg void OnViewTitlebar();
	afx_msg void OnViewWindowFrame();
	afx_msg void OnQuit();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnViewTopmost();
	afx_msg void OnWindowSnap();
	afx_msg void OnWindowDrag();
	afx_msg void OnScreenSaverStop();
	afx_msg void OnMonitorPowerOffStop();
	afx_msg void OnSystemStanbyStop();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnSelectWindowSize(UINT nID);
	afx_msg void OnSelectWindowZoom(UINT nID);
	afx_msg void OnWindowZoomConfig();
	afx_msg void OnWindowSizeConfig();
	afx_msg void OnAspectRatio4_3();
	afx_msg void OnAspectRatio16_9();
	afx_msg void OnAspectRatio10_11();
	afx_msg void OnAspectRatio40_33();
	afx_msg void OnAspectRatioCustom();
	afx_msg void OnAspectRatioInput();
	afx_msg void OnAspectRatioWindow();
	afx_msg void OnVideoProcAmp();
	afx_msg void OnWindowSizeZoom100X();
	afx_msg void OnSizing(UINT fwSide, LPRECT pRect);
	afx_msg void OnWindowAspectRatio();
	afx_msg void OnAudioVolume100();
	afx_msg void OnAudioVolume90();
	afx_msg void OnAudioVolume80();
	afx_msg void OnAudioVolume70();
	afx_msg void OnAudioVolume60();
	afx_msg void OnAudioVolume50();
	afx_msg void OnAudioVolume40();
	afx_msg void OnAudioVolume30();
	afx_msg void OnAudioVolume20();
	afx_msg void OnAudioVolume10();
	afx_msg void OnAudioVolume0();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnCropping();
	afx_msg void OnVersion();
	afx_msg LRESULT OnDisplayChange(WPARAM wParam, LPARAM lParam);
	afx_msg void OnClose();
	afx_msg void OnSnapshot();
	afx_msg void OnSnapshotConfig();
	afx_msg void OnSnapshotFolder();
	afx_msg void OnVmr9ProcAmp();
	afx_msg void OnEvrProcAmp();
	afx_msg void OnRenderer();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnKeyConfig();
	afx_msg void OnDeinterlace();
	afx_msg void OnAudioVolumeUp5();
	afx_msg void OnAudioVolumeDown5();
	afx_msg void OnAudioVolumeUp1();
	afx_msg void OnAudioVolumeDown1();
	afx_msg void OnAudioVolumeUp10();
	afx_msg void OnAudioVolumeDown10();
	afx_msg void OnMove(int x, int y);
	afx_msg void OnAudioMute();
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
};
