#pragma once
#include "afxcmn.h"
#include "afxwin.h"


// CProfileEditDlg _CAO

class CProfileEditDlg : public CDialog
{
	DECLARE_DYNAMIC(CProfileEditDlg)

public:
	CProfileEditDlg(CWnd* pParent = NULL);   // WRXgN^[
	virtual ~CProfileEditDlg();

// _CAO f[^
	enum { IDD = IDD_PROFILE_EDIT };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()

private:
	std::vector<CCaptureGraphProfile> profile_;
	CStatusBar status_;

	CListCtrl m_xcList;
	CButton m_xcBtnAdd;
	CButton m_xcBtnCopy;
	CButton m_xcBtnDel;
	CButton m_xcBtnUp;
	CButton m_xcBtnDown;
	CEdit m_xcEdit;

	bool sortName_;
	bool sortVideoName_;
	bool sortVideoFormat_;
	bool sortAudioName_;
	bool sortAudioFormat_;

public:
	void SetProfile(const std::vector<CCaptureGraphProfile>& profile);
	void GetProfile(std::vector<CCaptureGraphProfile>& profile);
	void UpdateStatus();
	void EnableCtrl(BOOL enable);

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnInitDialog();
	afx_msg void OnLvnGetdispinfoList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnColumnclickList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnChangeEdit();
	afx_msg void OnBnClickedBtnAdd();
	afx_msg void OnBnClickedBtnCopy();
	afx_msg void OnBnClickedBtnDel();
	afx_msg void OnBnClickedBtnUp();
	afx_msg void OnBnClickedBtnDown();
};
