#pragma once
#include "afxwin.h"
#include "EVRProcAmpPage.h"
#include "VMR9ProcAmpPage.h"


// CRendererPage _CAO

class CRendererPage : public CPropertyPage
{
	DECLARE_DYNAMIC(CRendererPage)

public:
	CRendererPage(CMainDlg *dlg, CCaptureGraphProfile *profile);
	virtual ~CRendererPage();

// _CAO f[^
	enum { IDD = IDD_RENDERER };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()

private:
	CCaptureGraphProfile store_; // ݒO̒lۑ

private:
	CMainDlg* const dlg_;
	CCaptureGraphProfile* const profile_;

	CVMR9ProcAmpPage* pageVmr9_; // _[ύXɏԂς邽
	CEVRProcAmpPage* pageEvr_; // _[ύXɏԂς邽

public:
	void SetPage(CVMR9ProcAmpPage *pageVmr9, CEVRProcAmpPage *pageEvr)
	{
		pageVmr9_ = pageVmr9;
		pageEvr_ = pageEvr;
	}

	CComboBox m_xcCmbVideo;
	CButton m_xcCbVideo;
	CComboBox m_xcCmbAudio;
	CButton m_xcCbAudio;
	CComboBox m_xcCmbResizer;

	virtual BOOL OnInitDialog();
	virtual void OnOK();

	afx_msg void OnCbnSelchangeCmbVideo();
	afx_msg void OnBnClickedCbVideo();
	afx_msg void OnCbnSelchangeCmbAudio();
	afx_msg void OnBnClickedCbAudio();
	afx_msg void OnCbnSelchangeCmbResizer();
};
