#pragma once

enum MOUSECODE {
	MOUSE_CODE_NONE = 0,
//	MOUSE_CODE_LBUTTON,
	MOUSE_CODE_LBUTTONDBL,
//	MOUSE_CODE_RBUTTON,
//	MOUSE_CODE_RBUTTONDBL,
	MOUSE_CODE_MBUTTON,
	MOUSE_CODE_MBUTTONDBL,
	MOUSE_CODE_XBUTTON1,
	MOUSE_CODE_XBUTTON1DBL,
	MOUSE_CODE_XBUTTON2,
	MOUSE_CODE_XBUTTON2DBL,
	MOUSE_CODE_WHEELUP,
	MOUSE_CODE_WHEELDOWN,
	MOUSE_CODE_END,
};

enum MODIFYCODE {
	MODIFY_CODE_NONE	= 0x00000000,
	MODIFY_CODE_SHIFT	= 0x00000001,
	MODIFY_CODE_CTRL	= 0x00000002,
	MODIFY_CODE_ALT		= 0x00000004,
	MODIFY_CODE_MASK	= MODIFY_CODE_SHIFT | MODIFY_CODE_CTRL | MODIFY_CODE_ALT,
};


DWORD ToKeyCode(char chara);
std::wstring GetMessageIDName(DWORD id);
std::wstring GetModifyCodeName(DWORD keycode);
std::wstring GetKeyCodeName(DWORD keycode);
std::wstring GetMouseCodeName(DWORD mousecode);

struct ShortCut {
	//typedef void (CMainDlg::*Task)();
	ShortCut(DWORD dwMessageID = 0, DWORD dwKeyModify = 0, DWORD dwKeyCode = 0, DWORD dwMouseModify = 0, DWORD dwMouseCode = 0)
		: dwMessageID(dwMessageID)
		, dwKeyModify(dwKeyModify)
		, dwKeyCode(dwKeyCode)
		, dwMouseModify(dwMouseModify)
		, dwMouseCode(dwMouseCode)
	{}

	DWORD dwMessageID; // ĂяoEBhEbZ[WID
	DWORD dwKeyModify; // CL[
	DWORD dwKeyCode;	// L[R[h
	DWORD dwMouseModify; // CL[
	DWORD dwMouseCode; // }EXR[h
};

void InitShortCut(std::vector<ShortCut>& data);

std::vector<ShortCut>::iterator FindKeyCode(std::vector<ShortCut>& x, DWORD modify, DWORD code);
std::vector<ShortCut>::iterator FindMouseCode(std::vector<ShortCut>& x, DWORD modify, DWORD code);

bool DeleteKeyCode(std::vector<ShortCut>& x, DWORD modify, DWORD code);
bool DeleteMouseCode(std::vector<ShortCut>& x, DWORD modify, DWORD code);