#pragma once
#include "afxcmn.h"
#include "afxwin.h"


// CShortCutDlg _CAO

class CShortCutDlg : public CDialog
{
	DECLARE_DYNAMIC(CShortCutDlg)

public:
	CShortCutDlg(CWnd* pParent = NULL);   // WRXgN^[
	virtual ~CShortCutDlg();

// _CAO f[^
	enum { IDD = IDD_SHORTCUT };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()

private:
	std::vector<ShortCut> data_;
	CBrush brush_;
	COLORREF color_;

	void InitializeData();
	void EnableControls(BOOL enable);
	void SettingControls(int index);
	void SettingMouseModify(int index);
	void SettingKeyModify(int index);
	void SettingKeyCapture(DWORD modify, DWORD code);

public:
	void GetShortCut(std::vector<ShortCut>& data);
	void SetShortCut(const std::vector<ShortCut>& data);

public:
	CListCtrl m_xcList;

	CEdit m_xcEdKey;
	CButton m_xcCbKeyShift;
	CButton m_xcCbKeyCtrl;
	CButton m_xcCbKeyAlt;
	CButton m_xcBtnKeyClear;

	//CComboBox m_xcCmbMouse;
	//CButton m_xcCbMouseShift;
	//CButton m_xcCbMouseCtrl;
	//CButton m_xcCbMouseAlt;
	//CButton m_xcBtnMouseClear;

	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnLvnGetdispinfoList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedCbKeyShift();
	afx_msg void OnBnClickedCbKeyCtrl();
	afx_msg void OnBnClickedCbKeyAlt();
	afx_msg void OnBnClickedBtnKeyClear();
	//afx_msg void OnCbnSelchangeCmbMouse();
	//afx_msg void OnBnClickedCbMouseShift();
	//afx_msg void OnBnClickedCbMouseCtrl();
	//afx_msg void OnBnClickedCbMouseAlt();
	//afx_msg void OnBnClickedBtnMouseClear();
	afx_msg void OnBnClickedBtnAllDefault();
	afx_msg void OnBnClickedBtnAllClear();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnEnSetfocusEdKey();
	afx_msg void OnEnKillfocusEdKey();
};
