// SnapShotDlg.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "SnapShotDlg.h"

// tH_I_CAÕR[obN
int __stdcall BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam,  LPARAM lpData)
{
	if (uMsg == BFFM_INITIALIZED)
	{
		SendMessage(hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, lpData);
	}
	return 0;
}


// CSnapShotDlg _CAO

IMPLEMENT_DYNAMIC(CSnapShotDlg, CDialog)

CSnapShotDlg::CSnapShotDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSnapShotDlg::IDD, pParent)
	, m_xvRadioType(0)
	, m_xvRadioSize(0)
{

}

CSnapShotDlg::~CSnapShotDlg()
{
}

void CSnapShotDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_FOLDER, m_xcEditFolder);
	DDX_Radio(pDX, IDC_RADIO_SAVE1, m_xvRadioType);
	DDX_Radio(pDX, IDC_RADIO_SIZE1, m_xvRadioSize);
	DDX_Control(pDX, IDC_CHECK_CROP, m_xcCheckCrop);
	DDX_Control(pDX, IDC_SB_JPEG, m_xcSBJpeg);
	DDX_Control(pDX, IDC_EDIT_JPEG, m_xcEditJpeg);
}


BEGIN_MESSAGE_MAP(CSnapShotDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_FOLDER, &CSnapShotDlg::OnBnClickedBtnFolder)
	ON_WM_HSCROLL()
END_MESSAGE_MAP()


// CSnapShotDlg bZ[W nh

BOOL CSnapShotDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// tH_
	m_xcEditFolder.SetWindowText(m_wsSnapShotFolder.c_str());

	// `
	switch (m_lSnapShotType)
	{
	case CSnapShot::FORMAT_BMP:
		m_xvRadioType = 0;
		break;

	case CSnapShot::FORMAT_JPG:
		m_xvRadioType = 1;
		break;

	case CSnapShot::FORMAT_PNG:
	default:
		m_xvRadioType = 2;
		break;
	}


	// TCY
	m_xvRadioSize = m_nSnapShotVideoSize;

	// Nbv
	m_xcCheckCrop.SetCheck(m_bSnapShotCrop ? BST_CHECKED : BST_UNCHECKED);


	// JPEGi
	if (m_nSnapShotJpegQuality > 100)
	{
		m_nSnapShotJpegQuality = 100;
	}
	else if (m_nSnapShotJpegQuality < 0)
	{
		m_nSnapShotJpegQuality = 0;
	}

	m_xcSBJpeg.SetScrollRange(0, 100);
	m_xcSBJpeg.SetScrollPos(m_nSnapShotJpegQuality);

	CString csTmp;
	csTmp.Format(L"%d", m_nSnapShotJpegQuality);
	m_xcEditJpeg.SetWindowText(csTmp);


	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CSnapShotDlg::OnDestroy()
{
	CDialog::OnDestroy();

	UpdateData(TRUE);

	CString csTmp;
	


	// tH_
	m_xcEditFolder.GetWindowText(csTmp);


	std::wstring wsTmp;

	wsTmp = csTmp;

	int index = (int)wsTmp.find_last_of(L'\\');
	if (index != wsTmp.npos &&
		index != (((int)wsTmp.size()) - 1))	// obNXbVpX̍Ōɖ
	{
		wsTmp += L"\\";
	}


	m_wsSnapShotFolder = wsTmp;



	// `
	switch (m_xvRadioType)
	{
	case 0:
		m_lSnapShotType = CSnapShot::FORMAT_BMP;
		break;

	case 1:
		m_lSnapShotType = CSnapShot::FORMAT_JPG;
		break;

	case 2:
	default:
		m_lSnapShotType = CSnapShot::FORMAT_PNG;
		break;
	}

	// TCY
	m_nSnapShotVideoSize = m_xvRadioSize;

	// Nbv
	m_bSnapShotCrop = m_xcCheckCrop.GetCheck() == BST_CHECKED ? TRUE : FALSE;

	// JPEGi
	m_nSnapShotJpegQuality = m_xcSBJpeg.GetScrollPos();
}


void CSnapShotDlg::OnBnClickedBtnFolder()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
    BROWSEINFO bInfo;
    LPITEMIDLIST pIDList;
    WCHAR wszDisplayName[MAX_PATH];
    
    // BROWSEINFO\̂ɒlݒ
    bInfo.hwndOwner			= GetSafeHwnd();          // _CAO̐eEChẼnh
    bInfo.pidlRoot			= NULL;                             // [gtH_ITEMIDLIST̃|C^ (NULL̏ꍇfXNgbvtH_g܂j
    bInfo.pszDisplayName	= wszDisplayName;                    // IꂽtH_󂯎obt@̃|C^
    bInfo.lpszTitle			= L"tH_̑I";             // c[r[̏㕔ɕ\镶 
    bInfo.ulFlags			= BIF_RETURNONLYFSDIRS;             // \tH_̎ނtO
    bInfo.lpfn				= BrowseCallbackProc;                             // BrowseCallbackProc֐̃|C^
	bInfo.lParam			= (LPARAM)m_wsSnapShotFolder.c_str();      // R[obN֐ɓnl

    // tH_I_CAO\
    pIDList = ::SHBrowseForFolder(&bInfo);
    if(pIDList == NULL)
	{
        // ߂lNULL̏ꍇAtH_IꂸɃ_CAOꂽƂӖ܂B
    }
	else
	{

        // ItemIDListpXɕϊ܂
        if(!::SHGetPathFromIDList(pIDList, wszDisplayName))
		{
            // G[
        }

		std::wstring wsPath;
		wsPath = wszDisplayName;


		int index = (int)wsPath.find_last_of(L'\\');
		if (index != wsPath.npos && index != (((int)wsPath.size()) - 1))
		{
			wsPath += L"\\";
		}

        // szDisplayNameɑIꂽtH_̃pXĂ܂
		m_xcEditFolder.SetWindowText(wsPath.c_str());

		m_wsSnapShotFolder = wsPath;


        // ŌpIDList̃|CgĂ郁J܂
        ::CoTaskMemFree(pIDList);
    }
}

void CSnapShotDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if (*pScrollBar != m_xcSBJpeg)
	{
		CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
	}

	int nNewPos = pScrollBar->GetScrollPos();

	switch (nSBCode)
	{
	// ܂݂hbO
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		nNewPos = nPos;
		break;

	// {^NbN
	case SB_LINELEFT:
	case SB_PAGELEFT:
		{
			nNewPos--;
			if (nNewPos < 0)
			{
				nNewPos = 0;
			}
			break;
		}
	// E{^NbN
	case SB_LINERIGHT:
	case SB_PAGERIGHT:
		{
			nNewPos++;
			if (nNewPos > 100)
			{
				nNewPos = 100;
			}
			break;
		}

	default:
		break;
	}

	m_xcSBJpeg.SetScrollPos(nNewPos);

	CString csTmp;
	csTmp.Format(L"%d", nNewPos);
	m_xcEditJpeg.SetWindowText(csTmp);
}

