// VideoProcAmpPage.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "VideoProcAmpPage.h"


// CVideoProcAmpPage _CAO

IMPLEMENT_DYNAMIC(CVideoProcAmpPage, CPropertyPage)

CVideoProcAmpPage::CVideoProcAmpPage(CMainDlg *dlg, CCaptureGraphProfile *profile)
	: CPropertyPage(CVideoProcAmpPage::IDD)
	, dlg_(dlg)
	, profile_(profile)
	, graph_(&(dlg->m_Preview))
	, cfg_(profile->VideoProcAmp)
{
	m_psp.dwFlags &= ~PSP_HASHELP;
}

CVideoProcAmpPage::~CVideoProcAmpPage()
{
}

void CVideoProcAmpPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SB_BRIGHTNESS, m_xcSBCtrl[0]);
	DDX_Control(pDX, IDC_SB_CONTRAST, m_xcSBCtrl[1]);
	DDX_Control(pDX, IDC_SB_HUE, m_xcSBCtrl[2]);
	DDX_Control(pDX, IDC_SB_SATURATION, m_xcSBCtrl[3]);
	DDX_Control(pDX, IDC_SB_SHARPNESS, m_xcSBCtrl[4]);
	DDX_Control(pDX, IDC_SB_GAMMA, m_xcSBCtrl[5]);
	DDX_Control(pDX, IDC_SB_COLOR_ENABLE, m_xcSBCtrl[6]);
	DDX_Control(pDX, IDC_SB_WHITE_BALANCE, m_xcSBCtrl[7]);
	DDX_Control(pDX, IDC_SB_BACKLIGHT_COMPENSATION, m_xcSBCtrl[8]);
	DDX_Control(pDX, IDC_SB_GAIN, m_xcSBCtrl[9]);
	DDX_Control(pDX, IDC_CB_BRIGHTNESS, m_xcCBCtrl[0]);
	DDX_Control(pDX, IDC_CB_CONTRAST, m_xcCBCtrl[1]);
	DDX_Control(pDX, IDC_CB_HUE, m_xcCBCtrl[2]);
	DDX_Control(pDX, IDC_CB_SATURATION, m_xcCBCtrl[3]);
	DDX_Control(pDX, IDC_CB_SHARPNESS, m_xcCBCtrl[4]);
	DDX_Control(pDX, IDC_CB_GAMMA, m_xcCBCtrl[5]);
	DDX_Control(pDX, IDC_CB_COLOR_ENABLE, m_xcCBCtrl[6]);
	DDX_Control(pDX, IDC_CB_WHITE_BALANCE, m_xcCBCtrl[7]);
	DDX_Control(pDX, IDC_CB_BACKLIGHT_COMPENSATION, m_xcCBCtrl[8]);
	DDX_Control(pDX, IDC_CB_GAIN, m_xcCBCtrl[9]);
	DDX_Control(pDX, IDC_BT_BRIGHTNESS, m_xcBTCtrl[0]);
	DDX_Control(pDX, IDC_BT_CONTRAST, m_xcBTCtrl[1]);
	DDX_Control(pDX, IDC_BT_HUE, m_xcBTCtrl[2]);
	DDX_Control(pDX, IDC_BT_SATURATION, m_xcBTCtrl[3]);
	DDX_Control(pDX, IDC_BT_SHARPNESS, m_xcBTCtrl[4]);
	DDX_Control(pDX, IDC_BT_GAMMA, m_xcBTCtrl[5]);
	DDX_Control(pDX, IDC_BT_COLOR_ENABLE, m_xcBTCtrl[6]);
	DDX_Control(pDX, IDC_BT_WHITE_BALANCE, m_xcBTCtrl[7]);
	DDX_Control(pDX, IDC_BT_BACKLIGHT_COMPENSATION, m_xcBTCtrl[8]);
	DDX_Control(pDX, IDC_BT_GAIN, m_xcBTCtrl[9]);
	DDX_Control(pDX, IDC_EB_BRIGHTNESS, m_xcEBCtrl[0]);
	DDX_Control(pDX, IDC_EB_CONTRAST, m_xcEBCtrl[1]);
	DDX_Control(pDX, IDC_EB_HUE, m_xcEBCtrl[2]);
	DDX_Control(pDX, IDC_EB_SATURATION, m_xcEBCtrl[3]);
	DDX_Control(pDX, IDC_EB_SHARPNESS, m_xcEBCtrl[4]);
	DDX_Control(pDX, IDC_EB_GAMMA, m_xcEBCtrl[5]);
	DDX_Control(pDX, IDC_EB_COLOR_ENABLE, m_xcEBCtrl[6]);
	DDX_Control(pDX, IDC_EB_WHITE_BALANCE, m_xcEBCtrl[7]);
	DDX_Control(pDX, IDC_EB_BACKLIGHT_COMPENSATION, m_xcEBCtrl[8]);
	DDX_Control(pDX, IDC_EB_GAIN, m_xcEBCtrl[9]);
	DDX_Control(pDX, IDC_BT_DEFAULT, m_xcBTDefault);
}


BEGIN_MESSAGE_MAP(CVideoProcAmpPage, CPropertyPage)
	ON_WM_DESTROY()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_CB_BRIGHTNESS, &CVideoProcAmpPage::OnBnClickedCbBrightness)
	ON_BN_CLICKED(IDC_CB_CONTRAST, &CVideoProcAmpPage::OnBnClickedCbContrast)
	ON_BN_CLICKED(IDC_CB_HUE, &CVideoProcAmpPage::OnBnClickedCbHue)
	ON_BN_CLICKED(IDC_CB_SATURATION, &CVideoProcAmpPage::OnBnClickedCbSaturation)
	ON_BN_CLICKED(IDC_CB_SHARPNESS, &CVideoProcAmpPage::OnBnClickedCbSharpness)
	ON_BN_CLICKED(IDC_CB_GAMMA, &CVideoProcAmpPage::OnBnClickedCbGamma)
	ON_BN_CLICKED(IDC_CB_COLOR_ENABLE, &CVideoProcAmpPage::OnBnClickedCbColorEnable)
	ON_BN_CLICKED(IDC_CB_WHITE_BALANCE, &CVideoProcAmpPage::OnBnClickedCbWhiteBalance)
	ON_BN_CLICKED(IDC_CB_BACKLIGHT_COMPENSATION, &CVideoProcAmpPage::OnBnClickedCbBacklightCompensation)
	ON_BN_CLICKED(IDC_CB_GAIN, &CVideoProcAmpPage::OnBnClickedCbGain)
	ON_BN_CLICKED(IDC_BT_BRIGHTNESS, &CVideoProcAmpPage::OnBnClickedBtBrightness)
	ON_BN_CLICKED(IDC_BT_CONTRAST, &CVideoProcAmpPage::OnBnClickedBtContrast)
	ON_BN_CLICKED(IDC_BT_HUE, &CVideoProcAmpPage::OnBnClickedBtHue)
	ON_BN_CLICKED(IDC_BT_SATURATION, &CVideoProcAmpPage::OnBnClickedBtSaturation)
	ON_BN_CLICKED(IDC_BT_SHARPNESS, &CVideoProcAmpPage::OnBnClickedBtSharpness)
	ON_BN_CLICKED(IDC_BT_GAMMA, &CVideoProcAmpPage::OnBnClickedBtGamma)
	ON_BN_CLICKED(IDC_BT_COLOR_ENABLE, &CVideoProcAmpPage::OnBnClickedBtColorEnable)
	ON_BN_CLICKED(IDC_BT_WHITE_BALANCE, &CVideoProcAmpPage::OnBnClickedBtWhiteBalance)
	ON_BN_CLICKED(IDC_BT_BACKLIGHT_COMPENSATION, &CVideoProcAmpPage::OnBnClickedBtBacklightCompensation)
	ON_BN_CLICKED(IDC_BT_GAIN, &CVideoProcAmpPage::OnBnClickedBtGain)
	ON_BN_CLICKED(IDC_BT_DEFAULT, &CVideoProcAmpPage::OnBnClickedBtDefault)
END_MESSAGE_MAP()


// CVideoProcAmpPage bZ[W nh
BOOL CVideoProcAmpPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	if (graph_ &&
		graph_->GetVideoProcAmp(range_))
	{
		// VideoProcAmp͏ݒlfoCXɂĕς̂
		// vt@Cݒ莞Ɍ肵Ă
		// ł͌ݒlvt@CɃRs[
		for (int i = 0; i < 10; i++)
		{
			cfg_[i].lValue = range_[i].lValue;
			cfg_[i].lFlags = range_[i].lFlags;
		}


		m_xcBTDefault.EnableWindow(FALSE);
		for (int i = 0; i < 10; i++)
		{
			// `FbN{bNX
			// tOLŉςȂ`FbNύX\
			if (range_[i].lCapsFlags != LONG_MIN &&
				range_[i].lCapsFlags == (VideoProcAmp_Flags_Auto|VideoProcAmp_Flags_Manual))
			{
				m_xcCBCtrl[i].EnableWindow(TRUE);
			}
			else
			{
				m_xcCBCtrl[i].EnableWindow(FALSE);
			}

			// tOLŎȂ`FbN
			if (range_[i].lFlags != LONG_MIN &&
				range_[i].lFlags & VideoProcAmp_Flags_Auto)
			{
				m_xcCBCtrl[i].SetCheck(BST_CHECKED);
			}
			else
			{
				m_xcCBCtrl[i].SetCheck(BST_UNCHECKED);
			}

			// XN[o[
			if (range_[i].lValue != LONG_MIN) // lL
			{
				// lXN[o[ɓKp
				int nMax = range_[i].lMax - range_[i].lMin;
				int nPos = range_[i].lValue - range_[i].lMin;
				if (range_[i].lSteppingDelta > 0)
				{
					nMax /= range_[i].lSteppingDelta;
					nPos /= range_[i].lSteppingDelta;
				}

				m_xcSBCtrl[i].SetScrollRange(0, nMax);
				m_xcSBCtrl[i].SetScrollPos(nPos);

				if (range_[i].lFlags != LONG_MIN &&  // tOL
					range_[i].lFlags & VideoProcAmp_Flags_Auto) // tO
				{
					m_xcEBCtrl[i].SetWindowText(L"");
					m_xcSBCtrl[i].EnableWindow(FALSE);
				}
				else
				{
					CString csTmp;
					csTmp.Format(L"%d", range_[i].lValue);
					m_xcEBCtrl[i].SetWindowText(csTmp);
					m_xcSBCtrl[i].EnableWindow(TRUE);
				}
			}
			else
			{
				m_xcEBCtrl[i].SetWindowText(L"");
				m_xcSBCtrl[i].EnableWindow(FALSE);
			}

			// {^
			if (range_[i].lValue != LONG_MIN ||
				range_[i].lCapsFlags == (VideoProcAmp_Flags_Auto|VideoProcAmp_Flags_Manual))
			{
				m_xcBTCtrl[i].EnableWindow(TRUE);
				m_xcBTDefault.EnableWindow(TRUE);
			}
			else
			{
				m_xcBTCtrl[i].EnableWindow(FALSE);
			}
		}
	}
	else
	{
		m_xcBTDefault.EnableWindow(FALSE);
		for (int i = 0; i < 10; i++)
		{
			m_xcSBCtrl[i].EnableWindow(FALSE);
			m_xcCBCtrl[i].EnableWindow(FALSE);
			m_xcBTCtrl[i].EnableWindow(FALSE);
		}
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void CVideoProcAmpPage::OnOK()
{
	CPropertyPage::OnOK();
}


void CVideoProcAmpPage::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int nNewPos = pScrollBar->GetScrollPos();

	for (int i = 0; i < 10; i++)
	{
		if (*pScrollBar != m_xcSBCtrl[i])
		{
			continue;
		}

		switch (nSBCode)
		{
		// ܂݂hbO
		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:
			nNewPos = nPos;
			break;

		// {^NbN
		case SB_LINELEFT:
		case SB_PAGELEFT:
			{
				nNewPos--;
				if (nNewPos < 0)
				{
					nNewPos = 0;
				}
				break;
			}
		// E{^NbN
		case SB_LINERIGHT:
		case SB_PAGERIGHT:
			{
				int nMax = range_[i].lMax - range_[i].lMin;
				if (range_[i].lSteppingDelta > 0)
				{
					nMax /= range_[i].lSteppingDelta;
				}

				nNewPos++;
				if (nNewPos > nMax)
				{
					nNewPos = nMax;
				}
				break;
			}

		default:
			break;
		}

		m_xcSBCtrl[i].SetScrollPos(nNewPos);

		long lValue = nNewPos;
		if (range_[i].lSteppingDelta > 0)
		{
			lValue *= range_[i].lSteppingDelta;
		}

		lValue += range_[i].lMin;

		if (graph_ != NULL)
		{
			if (cfg_[i].lValue != lValue)
			{
				graph_->SetVideoProcAmp(range_[i].lProperty, lValue, cfg_[i].lFlags);
				cfg_[i].lValue = lValue;
			}
		}

		CString csTmp;
		csTmp.Format(L"%d", lValue);
		m_xcEBCtrl[i].SetWindowText(csTmp);

		return;
	}

	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CVideoProcAmpPage::OnAutoCheck(int i)
{
	if (graph_ == NULL)
	{
		return;
	}

	long lFlags;
	if (m_xcCBCtrl[i].GetCheck() == BST_CHECKED)
	{
		lFlags = VideoProcAmp_Flags_Auto;

		m_xcEBCtrl[i].SetWindowText(L"");
		m_xcSBCtrl[i].EnableWindow(FALSE);
	}
	else
	{
		lFlags = VideoProcAmp_Flags_Manual;

		if (range_[i].lValue != LONG_MIN)
		{
			int nPos = cfg_[i].lValue - range_[i].lMin;
			if (range_[i].lSteppingDelta > 0)
			{
				nPos /= range_[i].lSteppingDelta;
			}
			m_xcSBCtrl[i].SetScrollPos(nPos);

			// GfBbg{bNX
			CString csTmp;
			csTmp.Format(L"%d", cfg_[i].lValue);
			m_xcEBCtrl[i].SetWindowText(csTmp);
			m_xcSBCtrl[i].EnableWindow(TRUE);
		}
		else
		{
			m_xcEBCtrl[i].SetWindowText(L"");
			m_xcSBCtrl[i].EnableWindow(FALSE);
		}
	}

	graph_->SetVideoProcAmp(range_[i].lProperty, cfg_[i].lValue, lFlags);
	cfg_[i].lFlags = lFlags;
}

void CVideoProcAmpPage::OnBnClickedCbBrightness()
{
	OnAutoCheck(0);
}

void CVideoProcAmpPage::OnBnClickedCbContrast()
{
	OnAutoCheck(1);
}

void CVideoProcAmpPage::OnBnClickedCbHue()
{
	OnAutoCheck(2);
}

void CVideoProcAmpPage::OnBnClickedCbSaturation()
{
	OnAutoCheck(3);
}

void CVideoProcAmpPage::OnBnClickedCbSharpness()
{
	OnAutoCheck(4);
}

void CVideoProcAmpPage::OnBnClickedCbGamma()
{
	OnAutoCheck(5);
}

void CVideoProcAmpPage::OnBnClickedCbColorEnable()
{
	OnAutoCheck(6);
}

void CVideoProcAmpPage::OnBnClickedCbWhiteBalance()
{
	OnAutoCheck(7);
}

void CVideoProcAmpPage::OnBnClickedCbBacklightCompensation()
{
	OnAutoCheck(8);
}

void CVideoProcAmpPage::OnBnClickedCbGain()
{
	OnAutoCheck(9);
}


void CVideoProcAmpPage::OnDefault(int i)
{
	if (graph_ == NULL)
	{
		return;
	}

	// `FbN{bNX
	if (range_[i].lCapsFlags != LONG_MIN &&
		range_[i].lCapsFlags & VideoProcAmp_Flags_Auto)
	{
		m_xcCBCtrl[i].SetCheck(BST_CHECKED);
	}
	else
	{
		m_xcCBCtrl[i].SetCheck(BST_UNCHECKED);
	}

	// XN[o[
	if (range_[i].lValue != LONG_MIN)
	{
		int nPos = range_[i].lDefault - range_[i].lMin;
		if (range_[i].lSteppingDelta > 0)
		{
			nPos /= range_[i].lSteppingDelta;
		}
		m_xcSBCtrl[i].SetScrollPos(nPos);

		if (range_[i].lFlags != LONG_MIN &&
			range_[i].lFlags & VideoProcAmp_Flags_Auto)
		{
			m_xcEBCtrl[i].SetWindowText(L"");
			m_xcSBCtrl[i].EnableWindow(FALSE);
		}
		else
		{
			// GfBbg{bNX
			CString csTmp;
			csTmp.Format(L"%d", range_[i].lDefault);
			m_xcEBCtrl[i].SetWindowText(csTmp);
			m_xcSBCtrl[i].EnableWindow(TRUE);
		}
	}
	else
	{
		m_xcEBCtrl[i].SetWindowText(L"");
		m_xcSBCtrl[i].EnableWindow(FALSE);
	}

	cfg_[i].lValue = range_[i].lDefault;

	if (range_[i].lCapsFlags != LONG_MIN &&
		range_[i].lCapsFlags && VideoProcAmp_Flags_Auto)
	{
		cfg_[i].lFlags = VideoProcAmp_Flags_Auto;
	}
	else
	{
		cfg_[i].lFlags = VideoProcAmp_Flags_Manual;
	}

	graph_->SetVideoProcAmp(range_[i].lProperty, cfg_[i].lValue, cfg_[i].lFlags);
}


void CVideoProcAmpPage::OnBnClickedBtBrightness()
{
	OnDefault(0);
}

void CVideoProcAmpPage::OnBnClickedBtContrast()
{
	OnDefault(1);
}

void CVideoProcAmpPage::OnBnClickedBtHue()
{
	OnDefault(2);
}

void CVideoProcAmpPage::OnBnClickedBtSaturation()
{
	OnDefault(3);
}

void CVideoProcAmpPage::OnBnClickedBtSharpness()
{
	OnDefault(4);
}

void CVideoProcAmpPage::OnBnClickedBtGamma()
{
	OnDefault(5);
}

void CVideoProcAmpPage::OnBnClickedBtColorEnable()
{
	OnDefault(6);
}

void CVideoProcAmpPage::OnBnClickedBtWhiteBalance()
{
	OnDefault(7);
}

void CVideoProcAmpPage::OnBnClickedBtBacklightCompensation()
{
	OnDefault(8);
}

void CVideoProcAmpPage::OnBnClickedBtGain()
{
	OnDefault(9);
}

void CVideoProcAmpPage::OnBnClickedBtDefault()
{
	for (int i = 0; i < 10; i++)
	{
		if (range_[i].lValue != LONG_MIN ||
			range_[i].lCapsFlags == (VideoProcAmp_Flags_Auto|VideoProcAmp_Flags_Manual))
		{
			OnDefault(i);
		}
	}
}
