#pragma once


// CCroppingPage _CAO

class CCroppingPage : public CPropertyPage
{
	DECLARE_DYNAMIC(CCroppingPage)

public:
	CCroppingPage(CMainDlg *dlg, CCaptureGraphProfile *profile, std::vector<CRect>* crop);
	virtual ~CCroppingPage();

// _CAO f[^
	enum { IDD = IDD_CROPPING };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()

private:
	CMainDlg* const dlg_;
	CCaptureGraphProfile* const profile_;
	std::vector<CRect>* const crop_;

private:
	CCaptureGraphBuilder* const graph_; // Otr_[
	RECT* const cfg_; // ݒl

public:
	virtual BOOL OnInitDialog();
	virtual void OnOK();

	CComboBox m_xcCbList;
	CButton m_xcBtnDel;
	CButton m_xcBtnAdd;

	CScrollBar m_xcSBCtrl[4];
	CEdit m_xcEDCtrl[4];
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnCbnSelchangeCbList();
	afx_msg void OnBnClickedBtnDel();
	afx_msg void OnBnClickedBtnAdd();
};
