// DeinterlacePage.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "DeinterlacePage.h"
#include "afxdialogex.h"

/*
C^[[X͏c𑜂ɂȂ邽߂Ԃ邽߂̕`I܂
Vv͒PɌtB[hRs[Ė߂܂
`Ԃ͌tB[h㉺̃tB[hč܂
uh͐`ԂƑÕt[ƍ܂
uh͐Î~̎Ɍڗ܂񂪎c܂
*/


// CDeinterlacePage _CAO

IMPLEMENT_DYNAMIC(CDeinterlacePage, CPropertyPage)

CDeinterlacePage::CDeinterlacePage(CMainDlg *dlg, CCaptureGraphProfile *profile)
	: CPropertyPage(CDeinterlacePage::IDD)
	, dlg_(dlg)
	, profile_(profile)
	, enableCtrl_(FALSE)
{
	m_psp.dwFlags &= ~PSP_HASHELP;
}

CDeinterlacePage::~CDeinterlacePage()
{
}

void CDeinterlacePage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_DEINT, m_xcCmbDeint);
	DDX_Control(pDX, IDC_CMB_FRAME, m_xcCmbFrame);
	DDX_Control(pDX, IDC_CMB_ORDER, m_xcCmbOrder);
}


BEGIN_MESSAGE_MAP(CDeinterlacePage, CPropertyPage)
	ON_CBN_SELCHANGE(IDC_CMB_DEINT, &CDeinterlacePage::OnCbnSelchangeCmbDeint)
	ON_CBN_SELCHANGE(IDC_CMB_FRAME, &CDeinterlacePage::OnCbnSelchangeCmbFrame)
	ON_CBN_SELCHANGE(IDC_CMB_ORDER, &CDeinterlacePage::OnCbnSelchangeCmbOrder)
END_MESSAGE_MAP()


// CDeinterlacePage bZ[W nh[


BOOL CDeinterlacePage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_xcCmbDeint.AddString(L"Ȃ");
	m_xcCmbDeint.AddString(L"Vv");
	m_xcCmbDeint.AddString(L"`");
	m_xcCmbDeint.AddString(L"`ԁ{V[v");
	m_xcCmbDeint.AddString(L"uh");
	m_xcCmbDeint.AddString(L"uh{V[v");
	m_xcCmbDeint.AddString(L"n[hEFA");

	switch (profile_->Preview.lTransformCopy)
	{
	case TRANSFORM_COPY_NONE:			m_xcCmbDeint.SetCurSel(0); break;
	case TRANSFORM_COPY_SIMPLE:			m_xcCmbDeint.SetCurSel(1); break;
	case TRANSFORM_COPY_LINER:			m_xcCmbDeint.SetCurSel(2); break;
	case TRANSFORM_COPY_LINER_SHARP:	m_xcCmbDeint.SetCurSel(3); break;
	case TRANSFORM_COPY_BLEND:			m_xcCmbDeint.SetCurSel(4); break;
	case TRANSFORM_COPY_BLEND_SHARP:	m_xcCmbDeint.SetCurSel(5); break;
	case TRANSFORM_COPY_HARDWARE:		m_xcCmbDeint.SetCurSel(6); break;
	default:							m_xcCmbDeint.SetCurSel(0); break;
	}

	m_xcCmbFrame.AddString(L"fps {");
	m_xcCmbFrame.AddString(L"fps 1/2{");
	m_xcCmbFrame.AddString(L"fps 2{");

	switch (profile_->Preview.lTransformFrame)
	{
	case TRANSFORM_FRAME_NONE:			m_xcCmbFrame.SetCurSel(0); break;
	case TRANSFORM_FRAME_HALF:			m_xcCmbFrame.SetCurSel(1); break;
	case TRANSFORM_FRAME_DOUBLE:		m_xcCmbFrame.SetCurSel(2); break;
	default:							m_xcCmbFrame.SetCurSel(0); break;
	}

	m_xcCmbOrder.AddString(L"gbv{gitB[hj");
	m_xcCmbOrder.AddString(L"{ggbvitB[hj");

	switch (profile_->Preview.lTransformFieldOrder)
	{
	case TRANSFORM_FIELD_ORDER_ODD:		m_xcCmbOrder.SetCurSel(0); break;
	case TRANSFORM_FIELD_ORDER_EVEN:	m_xcCmbOrder.SetCurSel(1); break;
	default:							m_xcCmbOrder.SetCurSel(0); break;
	}

	EnableCtrl(enableCtrl_);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}



void CDeinterlacePage::OnOK()
{

	CPropertyPage::OnOK();
}




void CDeinterlacePage::OnCbnSelchangeCmbDeint()
{
	long copy = profile_->Preview.lTransformCopy;
	long xcopy = copy;
	long frame = profile_->Preview.lTransformFrame;
	long xframe = frame;
	bool rebuild = false;

	// ύXǂݎ
	switch (m_xcCmbDeint.GetCurSel())
	{
	case 0:		xcopy = TRANSFORM_COPY_NONE;		xframe = TRANSFORM_FRAME_NONE;		break;
	case 1:		xcopy = TRANSFORM_COPY_SIMPLE;		xframe = TRANSFORM_FRAME_DOUBLE;	break;
	case 2:		xcopy = TRANSFORM_COPY_LINER;		xframe = TRANSFORM_FRAME_DOUBLE;	break;
	case 3:		xcopy = TRANSFORM_COPY_LINER_SHARP;	xframe = TRANSFORM_FRAME_DOUBLE;	break;
	case 4:		xcopy = TRANSFORM_COPY_BLEND;		xframe = TRANSFORM_FRAME_DOUBLE;	break;
	case 5:		xcopy = TRANSFORM_COPY_BLEND_SHARP;	xframe = TRANSFORM_FRAME_DOUBLE;	break;
	case 6:		xcopy = TRANSFORM_COPY_HARDWARE;	xframe = TRANSFORM_FRAME_DOUBLE;	break;
	default:	xcopy = TRANSFORM_COPY_NONE;		xframe = TRANSFORM_FRAME_NONE;		break;
	}

	profile_->Preview.lTransformCopy = xcopy;
	profile_->Preview.lTransformFrame = xframe;

	EnableCtrl(enableCtrl_);

	// n[hEFAA̓n[hEFA֕ύXꂽrh
	if (xcopy != copy)
	{
		if (xcopy == TRANSFORM_COPY_HARDWARE || copy == TRANSFORM_COPY_HARDWARE)
		{
			rebuild = true;
		}
	}

	// ǂݎŃt[[gύXꂽ
	if (xframe != frame)
	{
		// t[[gR{{bNXɐݒ
		switch (xframe)
		{
		case TRANSFORM_FRAME_NONE:			m_xcCmbFrame.SetCurSel(0); break;
		case TRANSFORM_FRAME_HALF:			m_xcCmbFrame.SetCurSel(1); break;
		case TRANSFORM_FRAME_DOUBLE:		m_xcCmbFrame.SetCurSel(2); break;
		default:							m_xcCmbFrame.SetCurSel(0); break;
		}

		// n[hEFA2{A2{֕ύXꂽrh
		if (xcopy == TRANSFORM_COPY_HARDWARE)
		{
			if (xframe == TRANSFORM_FRAME_DOUBLE || frame == TRANSFORM_FRAME_DOUBLE)
			{
				rebuild = true;
			}
		}
	}


	// tB^L
	if (profile_->Preview.bTransform)
	{
		if (rebuild)
		{// rh
			dlg_->OnPreviewIsRunBuild();
		}
		else
		{// ݒύX̂
			dlg_->m_Preview.SetTransformCopy(xcopy);
			dlg_->m_Preview.SetTransformFrame(xframe);
		}
	}
}


void CDeinterlacePage::OnCbnSelchangeCmbFrame()
{
	long last = profile_->Preview.lTransformFrame;
	long next = last;

	switch (m_xcCmbFrame.GetCurSel())
	{
	case 0:		next = TRANSFORM_FRAME_NONE;	break;
	case 1:		next = TRANSFORM_FRAME_HALF;	break;
	case 2:		next = TRANSFORM_FRAME_DOUBLE;	break;
	default:	next = TRANSFORM_FRAME_NONE;	break;
	}

	profile_->Preview.lTransformFrame = next;


	if (profile_->Preview.bTransform)
	{
		if (profile_->Preview.lTransformCopy == TRANSFORM_COPY_HARDWARE &&
			last != next &&
			(last == TRANSFORM_FRAME_DOUBLE || next == TRANSFORM_FRAME_DOUBLE))
		{
			dlg_->OnPreviewIsRunBuild();
		}
		else
		{
			dlg_->m_Preview.SetTransformFrame(next);
		}
	}
}


void CDeinterlacePage::OnCbnSelchangeCmbOrder()
{
	long next = profile_->Preview.lTransformFieldOrder;

	switch (m_xcCmbOrder.GetCurSel())
	{
	case 0:		next = TRANSFORM_FIELD_ORDER_ODD;	break;
	case 1:		next = TRANSFORM_FIELD_ORDER_EVEN;	break;
	default:	next = TRANSFORM_FIELD_ORDER_ODD;	break;
	}

	profile_->Preview.lTransformFieldOrder = next;

	if (profile_->Preview.bTransform)
	{
		dlg_->m_Preview.SetTransformFieldOrder(next);
	}
}

void CDeinterlacePage::EnableCtrl(BOOL enable)
{
	if (IsWindow(m_hWnd))
	{
		m_xcCmbDeint.EnableWindow(enable);

		if (enable && profile_->Preview.lTransformCopy == TRANSFORM_COPY_NONE)
		{
			m_xcCmbFrame.EnableWindow(FALSE);
			m_xcCmbOrder.EnableWindow(FALSE);
		}
		else
		{
			m_xcCmbFrame.EnableWindow(enable);
			m_xcCmbOrder.EnableWindow(enable);
		}
	}
	enableCtrl_ = enable;
}