#pragma once
//#include "IPeCaTVFilterCtrl.h"

// fC^[[X^t[
typedef enum _TRANSFORM_COPY {
	TRANSFORM_COPY_NONE = 0,
	TRANSFORM_COPY_SIMPLE,				// Vv
	TRANSFORM_COPY_LINER,				// `
	TRANSFORM_COPY_LINER_SHARP,				// `
	TRANSFORM_COPY_BLEND,				// uh
	TRANSFORM_COPY_BLEND_SHARP,				// uh
	TRANSFORM_COPY_HARDWARE,			// n[hEFA
} TRANSFORM_COPY;

// t[
typedef enum _TRANSFORM_FRAME {
	TRANSFORM_FRAME_NONE = 0,
	TRANSFORM_FRAME_HALF,			// 1/2
	TRANSFORM_FRAME_DOUBLE,			// 2
} TRANSFORM_FRAME;

// YCL
typedef enum _TRANSFORM_YCEXPAND {
	TRANSFORM_YCEXPAND_NONE = 0,	// Ȃ
	TRANSFORM_YCEXPAND_UYVY,		// UYVYoCgz
	TRANSFORM_YCEXPAND_YUY2,		// YUY2oCgz
} TRANSFORM_YCEXPAND;

// tB[hI[_[
typedef enum _TRANSFORM_FIELD_ORDER {
	TRANSFORM_FIELD_ORDER_ODD = 0,	// tB[h
	TRANSFORM_FIELD_ORDER_EVEN,		// tB[h
} TRANSFORM_FIELD_ORDER;

// ]
typedef enum _TRANSFORM_ROTATION {
	TRANSFORM_ROTATION_NONE = 0,
	TRANSFORM_ROTATION_R90,		// E90x
	TRANSFORM_ROTATION_L90,		// 90x
	TRANSFORM_ROTATION_180,		// 180x
} TRANSFORM_ROTATION;


// {14F7A42C-CA71-489f-8B9E-4322FB87A560}
DEFINE_GUID(IID_IPeCaTVFilterCtrl, 
0x14f7a42c, 0xca71, 0x489f, 0x8b, 0x9e, 0x43, 0x22, 0xfb, 0x87, 0xa5, 0x60);

DECLARE_INTERFACE_(IPeCaTVFilterCtrl, IUnknown) 
{
	STDMETHOD(SetTransformCopy) (THIS_ long _trans_copy) PURE;
	STDMETHOD(GetTransformCopy) (THIS_ long &_trans_copy) PURE;
	STDMETHOD(SetTransformFrame) (THIS_ long _trans_frame) PURE;
	STDMETHOD(GetTransformFrame) (THIS_ long &_trans_frame) PURE;
	STDMETHOD(SetTransformFieldOrder) (THIS_ long _trans_order) PURE;
	STDMETHOD(GetTransformFieldOrder) (THIS_ long &_trans_order) PURE;
	STDMETHOD(SetTransformYCExpand) (THIS_ long _trans_ycexpand) PURE;
	STDMETHOD(GetTransformYCExpand) (THIS_ long &_trans_ycexpand) PURE;
	STDMETHOD(SetTransformRotation) (THIS_ long _trans_rotation) PURE;
	STDMETHOD(GetTransformRotation) (THIS_ long &_trans_rotation) PURE;
	STDMETHOD(SetTransformFlipHorizontal) (THIS_ BOOL _trans_filp) PURE;
	STDMETHOD(GetTransformFlipHorizontal) (THIS_ BOOL &_trans_filp) PURE;
	STDMETHOD(SetTransformFlipVertical) (THIS_ BOOL _trans_filp) PURE;
	STDMETHOD(GetTransformFlipVertical) (THIS_ BOOL &_trans_filp) PURE;
	STDMETHOD(SetTransformDoubleHeight) (THIS_ BOOL _trans_double) PURE;
	STDMETHOD(GetTransformDoubleHeight) (THIS_ BOOL &_trans_double) PURE;
};

