#pragma once
#include "afxwin.h"
#include "DeinterlacePage.h"
#include "YCExpandPage.h"
#include "RotationPage.h"

// CInnerFilterPage _CAO

class CInnerFilterPage : public CPropertyPage
{
	DECLARE_DYNAMIC(CInnerFilterPage)

public:
	CInnerFilterPage(CMainDlg *dlg, CCaptureGraphProfile *profile);
	virtual ~CInnerFilterPage();

// _CAO f[^
	enum { IDD = IDD_INNERFILTER };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()

private:
	CMainDlg* const dlg_;
	CCaptureGraphProfile* const profile_;
	BOOL enableCtrl_;

	// ύXɏԂς邽
	CDeinterlacePage* pageDeint_;
	CYCExpandPage* pageYCE_;
	CRotationPage* pageRot_;

public:
	void SetPage(CDeinterlacePage* pageDeint, CYCExpandPage* pageYCE, CRotationPage* pageRot)
	{
		pageDeint_ = pageDeint;
		pageYCE_ = pageYCE;
		pageRot_ = pageRot;
	}

	CButton m_xcCbEnable;
	virtual BOOL OnInitDialog();
	virtual void OnOK();

	afx_msg void OnBnClickedCbEnable();

	void EnableCtrl(BOOL enable);
};
