// MainDlg.cpp : t@C
//

#include "stdafx.h"
#include "MainDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

 // j[WI{^ݒ̒Zk
static BOOL CheckMenuRadio(CMenu *menu, UINT command, UINT check = MF_CHECKED)
{
	return menu->CheckMenuRadioItem(
		command,
		command,
		command, check|MF_BYCOMMAND);
}


// CMainDlg _CAO
CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_bFullScreen = FALSE;
	m_bWindowDragFlag = FALSE;
}

void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_RBUTTONUP()
	ON_COMMAND(IDM_DEBUG01, &CMainDlg::OnDebug01)
	ON_COMMAND(IDM_DEBUG02, &CMainDlg::OnDebug02)
	ON_MESSAGE(WM_GRAPH_NOTIFY, &CMainDlg::OnGraphNotify)
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(IDM_REGISTER_PROFILE, &CMainDlg::OnRegisterProfile)
	ON_COMMAND_RANGE(IDM_PROFILE_RANGE_START, IDM_PROFILE_RANGE_END, &CMainDlg::OnSelectProfile)
	ON_COMMAND_RANGE(IDM_FILTERGRAPH_RANGE_START, IDM_FILTERGRAPH_RANGE_END, &CMainDlg::OnSelectFilterGraph)
	ON_COMMAND(IDM_TRANSFORM, &CMainDlg::OnTransform)
	ON_COMMAND(IDM_TRANSFORM_COPY_NONE, &CMainDlg::OnTransformCopyNone)
	ON_COMMAND(IDM_TRANSFORM_COPY_SIMPLE, &CMainDlg::OnTransformCopySimple)
	ON_COMMAND(IDM_TRANSFORM_COPY_LINER, &CMainDlg::OnTransformCopyLiner)
	ON_COMMAND(IDM_TRANSFORM_COPY_LINER_SHARP, &CMainDlg::OnTransformCopyLinerSharp)
	ON_COMMAND(IDM_TRANSFORM_COPY_BLEND, &CMainDlg::OnTransformCopyBlend)
	ON_COMMAND(IDM_TRANSFORM_COPY_BLEND_SHARP, &CMainDlg::OnTransformCopyBlendSharp)
	ON_COMMAND(IDM_TRANSFORM_COPY_HARDWARE, &CMainDlg::OnTransformCopyHardware)
	ON_COMMAND(IDM_TRANSFORM_FRAME_NONE, &CMainDlg::OnTransformFrameNone)
	ON_COMMAND(IDM_TRANSFORM_FRAME_HALF, &CMainDlg::OnTransformFrameHalf)
	ON_COMMAND(IDM_TRANSFORM_FRAME_DOUBLE, &CMainDlg::OnTransformFrameDouble)
	ON_COMMAND(IDM_TRANSFORM_FLIP_VERTICAL, &CMainDlg::OnTransformFlipVertical)
	ON_COMMAND(IDM_TRANSFORM_YCEXPAND_NONE, &CMainDlg::OnTransformYcexpandNone)
	ON_COMMAND(IDM_TRANSFORM_YCEXPAND_UYVY, &CMainDlg::OnTransformYcexpandUyvy)
	ON_COMMAND(IDM_TRANSFORM_YCEXPAND_YUY2, &CMainDlg::OnTransformYcexpandYuv2)
	ON_COMMAND(IDM_TRANSFORM_FIELD_ORDER_ODD, &CMainDlg::OnTransformFieldOrderOdd)
	ON_COMMAND(IDM_TRANSFORM_FIELD_ORDER_EVEN, &CMainDlg::OnTransformFieldOrderEven)
	ON_COMMAND(IDM_PREVIEW_RUN, &CMainDlg::OnPreviewRun)
	ON_COMMAND(IDM_PREVIEW_STOP, &CMainDlg::OnPreviewStop)
	ON_COMMAND(IDM_PREVIEW_BUILD, &CMainDlg::OnPreviewBuild)
	ON_COMMAND(IDM_PROCESS_PRIORITY_REALTIME, &CMainDlg::OnProcessPriorityRealtime)
	ON_COMMAND(IDM_PROCESS_PRIORITY_HIGH, &CMainDlg::OnProcessPriorityHigh)
	ON_COMMAND(IDM_PROCESS_PRIORITY_ABOVE_NORMAL, &CMainDlg::OnProcessPriorityAboveNormal)
	ON_COMMAND(IDM_PROCESS_PRIORITY_NORMAL, &CMainDlg::OnProcessPriorityNormal)
	ON_COMMAND(IDM_PROCESS_PRIORITY_BELOW_NOMAL, &CMainDlg::OnProcessPriorityBelowNomal)
	ON_COMMAND(IDM_PROCESS_PRIORITY_IDLE, &CMainDlg::OnProcessPriorityIdle)
	ON_COMMAND(IDM_VIEW_TITLEBAR, &CMainDlg::OnViewTitlebar)
	ON_COMMAND(IDM_VIEW_WINDOW_FRAME, &CMainDlg::OnViewWindowFrame)
	ON_COMMAND(IDM_QUIT, &CMainDlg::OnQuit)
	ON_WM_MOUSEMOVE()
	ON_COMMAND(IDM_VIEW_TOPMOST, &CMainDlg::OnViewTopmost)
	ON_COMMAND(IDM_WINDOW_SNAP, &CMainDlg::OnWindowSnap)
	ON_COMMAND(IDM_WINDOW_DRAG, &CMainDlg::OnWindowDrag)
	ON_COMMAND(IDM_SCREEN_SAVER_STOP, &CMainDlg::OnScreenSaverStop)
	ON_COMMAND(IDM_MONITOR_POWER_OFF_STOP, &CMainDlg::OnMonitorPowerOffStop)
	ON_COMMAND(IDM_SYSTEM_STANBY_STOP, &CMainDlg::OnSystemStanbyStop)
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEWHEEL()
	ON_COMMAND_RANGE(IDM_WINDOWSIZE_RANGE_START, IDM_WINDOWSIZE_RANGE_END, &CMainDlg::OnSelectWindowSize)
	ON_COMMAND_RANGE(IDM_WINDOWZOOM_RANGE_START, IDM_WINDOWZOOM_RANGE_END, &CMainDlg::OnSelectWindowZoom)
	ON_COMMAND(IDM_WINDOW_ZOOM_CONFIG, &CMainDlg::OnWindowZoomConfig)
	ON_COMMAND(IDM_WINDOW_SIZE_CONFIG, &CMainDlg::OnWindowSizeConfig)
	ON_COMMAND(IDM_ASPECT_RATIO_4_3, &CMainDlg::OnAspectRatio4_3)
	ON_COMMAND(IDM_ASPECT_RATIO_16_9, &CMainDlg::OnAspectRatio16_9)
	ON_COMMAND(IDM_ASPECT_RATIO_40_33, &CMainDlg::OnAspectRatio40_33)
	ON_COMMAND(IDM_ASPECT_RATIO_10_11, &CMainDlg::OnAspectRatio10_11)
	ON_COMMAND(IDM_ASPECT_RATIO_CUSTOM, &CMainDlg::OnAspectRatioCustom)
	ON_COMMAND(IDM_ASPECT_RATIO_INPUT, &CMainDlg::OnAspectRatioInput)
	ON_COMMAND(IDM_ASPECT_RATIO_WINDOW, &CMainDlg::OnAspectRatioWindow)
	ON_COMMAND(IDM_VIDEO_PROC_AMP, &CMainDlg::OnVideoProcAmp)
	ON_COMMAND(IDM_WINDOW_SIZE_ZOOM_100X, &CMainDlg::OnWindowSizeZoom100X)
	ON_WM_SIZING()
	ON_COMMAND(IDM_WINDOW_ASPECT_RATIO, &CMainDlg::OnWindowAspectRatio)
	ON_COMMAND(IDM_AUDIO_VOLUME_100, &CMainDlg::OnAudioVolume100)
	ON_COMMAND(IDM_AUDIO_VOLUME_90, &CMainDlg::OnAudioVolume90)
	ON_COMMAND(IDM_AUDIO_VOLUME_80, &CMainDlg::OnAudioVolume80)
	ON_COMMAND(IDM_AUDIO_VOLUME_70, &CMainDlg::OnAudioVolume70)
	ON_COMMAND(IDM_AUDIO_VOLUME_60, &CMainDlg::OnAudioVolume60)
	ON_COMMAND(IDM_AUDIO_VOLUME_50, &CMainDlg::OnAudioVolume50)
	ON_COMMAND(IDM_AUDIO_VOLUME_40, &CMainDlg::OnAudioVolume40)
	ON_COMMAND(IDM_AUDIO_VOLUME_30, &CMainDlg::OnAudioVolume30)
	ON_COMMAND(IDM_AUDIO_VOLUME_20, &CMainDlg::OnAudioVolume20)
	ON_COMMAND(IDM_AUDIO_VOLUME_10, &CMainDlg::OnAudioVolume10)
	ON_COMMAND(IDM_AUDIO_VOLUME_0, &CMainDlg::OnAudioVolume0)
	ON_WM_SYSCOMMAND()
	ON_COMMAND(IDM_CROPPING, &CMainDlg::OnCropping)
	ON_COMMAND(IDM_VERSION, &CMainDlg::OnVersion)
	ON_MESSAGE(WM_DISPLAYCHANGE, &CMainDlg::OnDisplayChange)
	ON_WM_CLOSE()
	ON_COMMAND(IDM_SNAPSHOT, &CMainDlg::OnSnapshot)
	ON_COMMAND(IDM_SNAPSHOT_CONFIG, &CMainDlg::OnSnapshotConfig)
	ON_COMMAND(IDM_SNAPSHOT_FOLDER, &CMainDlg::OnSnapshotFolder)
	ON_COMMAND(IDM_VMR9_PROC_AMP, &CMainDlg::OnVmr9ProcAmp)
	ON_COMMAND(IDM_EVR_PROC_AMP, &CMainDlg::OnEvrProcAmp)
	ON_COMMAND(IDM_RENDERER, &CMainDlg::OnRenderer)
	ON_WM_TIMER()
	ON_COMMAND(IDM_KEY_CONFIG, &CMainDlg::OnKeyConfig)
	ON_COMMAND(IDM_DEINTERLACE, &CMainDlg::OnDeinterlace)
	ON_COMMAND(IDM_AUDIO_VOLUME_UP5, &CMainDlg::OnAudioVolumeUp5)
	ON_COMMAND(IDM_AUDIO_VOLUME_DOWN5, &CMainDlg::OnAudioVolumeDown5)
	ON_COMMAND(IDM_AUDIO_VOLUME_UP1, &CMainDlg::OnAudioVolumeUp1)
	ON_COMMAND(IDM_AUDIO_VOLUME_DOWN1, &CMainDlg::OnAudioVolumeDown1)
	ON_COMMAND(IDM_AUDIO_VOLUME_UP10, &CMainDlg::OnAudioVolumeUp10)
	ON_COMMAND(IDM_AUDIO_VOLUME_DOWN10, &CMainDlg::OnAudioVolumeDown10)
	ON_WM_MOVE()
	ON_COMMAND(IDM_AUDIO_MUTE, &CMainDlg::OnAudioMute)
	ON_WM_MBUTTONDOWN()
	END_MESSAGE_MAP()


// CMainDlg bZ[W nh

BOOL CMainDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetWindowText(L"PeCaTV2");

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	g_cfg.LoadConfig();
	g_cfg.LoadProfile();

	// Jgvt@Cݒ
	try {
		profile_ = g_cfg.m_vecProfile.at(g_cfg.m_nProfileSelected);
	}
	catch (std::exception const&) {}

	// EBhEʒu
	SetWindowPlacement(&g_cfg.m_stWndPlacement);

	// tXN[p̃EBhEʒuʒuɏ
	m_stWndRestore = g_cfg.m_stWndPlacement;


	if (!g_cfg.m_bWindowFrame)
	{
		// EBhEt[
		ModifyStyle(WS_CAPTION|WS_THICKFRAME, 0);
		SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE|SWP_NOZORDER|SWP_FRAMECHANGED);
	}
	else if (!g_cfg.m_bTitleBar)
	{
		// ^Cgo[
		ModifyStyle(WS_CAPTION, 0);
		SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE|SWP_NOZORDER|SWP_FRAMECHANGED);
	}

	if (g_cfg.m_bTopMost)
	{
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
	}


	// LȃTCYRNV
	m_vecWindowSize.clear();
	for (std::vector<WindowSize>::iterator it = g_cfg.m_vecWindowSize.begin(), end = g_cfg.m_vecWindowSize.end();
		it != end; ++it)
	{
		if (it->enable)
		{
			m_vecWindowSize.push_back(*it);
		}
	}

	m_vecWindowZoom.clear();
	for (std::vector<WindowZoom>::iterator it = g_cfg.m_vecWindowZoom.begin(), end = g_cfg.m_vecWindowZoom.end();
		it != end; ++it)
	{
		if (it->enable)
		{
			m_vecWindowZoom.push_back(*it);
		}
	}



	SetProcessPriority(profile_.Preview.lProcessPriority);


	switch(profile_.Preview.lAspectRatio)
	{
	case ASPECT_RATIO_INPUT:
		m_Preview.SetAspectRatio(-1, -1);
		break;

	case ASPECT_RATIO_4_3:
		m_Preview.SetAspectRatio(4, 3);
		break;

	case ASPECT_RATIO_16_9:
		m_Preview.SetAspectRatio(16, 9);
		break;

	case ASPECT_RATIO_40_33:
		m_Preview.SetAspectRatio(40, 33);
		break;

	case ASPECT_RATIO_10_11:
		m_Preview.SetAspectRatio(10, 11);
		break;

	case ASPECT_RATIO_CUSTOM:
		m_Preview.SetAspectRatio(profile_.Preview.nAspectX, profile_.Preview.nAspectY);
		break;

	case ASPECT_RATIO_WINDOW:
		m_Preview.SetAspectRatio(-2, -2);
		break;

	default:
		m_Preview.SetAspectRatio(-1, -1);
		break;
	}

	// ܂rfITCY擾łȂ̂
	// ̓AXyNg̑Ɍ݂̃NCAgTCYrfITCYƂ
	CRect rc;
	GetClientRect(&rc);
	m_Preview.SetVideoSize(rc.Width(), rc.Height());


	StartCaptionTimer();

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}


BOOL CMainDlg::PreTranslateMessage(MSG* pMsg)
{
	switch (pMsg->message)
	{
	case WM_KEYDOWN:
	case WM_SYSKEYDOWN:
		{
			DWORD code = static_cast<DWORD>(pMsg->wParam);
			DWORD shift = (GetAsyncKeyState(VK_SHIFT) & 0x8000) ? MODIFY_CODE_SHIFT : 0;
			DWORD ctrl = (GetAsyncKeyState(VK_CONTROL) & 0x8000) ? MODIFY_CODE_CTRL : 0;
			DWORD alt = (GetAsyncKeyState(VK_MENU) & 0x8000) ? MODIFY_CODE_ALT : 0;
			DWORD modify = shift | ctrl | alt;

			std::vector<ShortCut>::iterator it = FindKeyCode(g_cfg.m_vecShortCut, modify, code);
			if (it != g_cfg.m_vecShortCut.end())
			{
				PostMessage(WM_COMMAND, it->dwMessageID);
				return TRUE;
			}

			// _CAOx[XȂ̂ŕȂ悤ɓׂ͂
			if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
			{
				return TRUE;
			}
		}
		break;
	}

	return CDialog::PreTranslateMessage(pMsg);
}


// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CMainDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		if (!m_Preview.RepaintVideo())
		{
			// wihԂ
			CPaintDC dc(this);

			CRect rect;
			GetClientRect(&rect);
			CBrush brush;
			brush.CreateSolidBrush(RGB(0, 0, 0));
			dc.FillRect(rect,&brush);
		}

		//CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CMainDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CMainDlg::OnDestroy()
{
	CDialog::OnDestroy();

	EndCaptionTimer();

	m_Preview.GetVideoProcAmpConfig(profile_.VideoProcAmp);

	m_Preview.UnInit();

	if (m_bFullScreen)
	{
		g_cfg.m_stWndPlacement = m_stWndRestore;
	}
	else
	{
		::ZeroMemory(&g_cfg.m_stWndPlacement, sizeof(WINDOWPLACEMENT));
		g_cfg.m_stWndPlacement.length = sizeof(WINDOWPLACEMENT);
		GetWindowPlacement(&g_cfg.m_stWndPlacement);
	}

	if (!g_cfg.m_bMultiBoot)
	{
		// Jgvt@Cۑ
		try {
			g_cfg.m_vecProfile.at(g_cfg.m_nProfileSelected) = profile_;
		}
		catch (std::exception const&) {}

		g_cfg.SaveConfig();
		g_cfg.SaveProfile();
	}
}

//---------------------------------------------------------------------------------------
// ENbNj[
void CMainDlg::OnRButtonUp(UINT nFlags, CPoint point)
{
	// EBhEhbOtO
	if (m_bWindowDragFlag)
	{
		m_bWindowDragFlag = FALSE;
		ReleaseCapture();
	}

	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if (m_bFullScreen)
	{
		EndMouseHideTimer();
	}

	CMenu *pMenu = NULL;
	CMenu cMenu;

	CPoint pt;
	GetCursorPos(&pt);

	if (!cMenu.LoadMenu(IDR_WINDOW_MENU))
	{
		return;
	}
	
	if ((pMenu = cMenu.GetSubMenu(0)) == NULL)
	{
		return;
	}

#ifndef _DEBUG
	pMenu->DeleteMenu(IDM_DEBUG01, MF_BYCOMMAND);
	pMenu->DeleteMenu(IDM_DEBUG02, MF_BYCOMMAND);
#endif

	//@vt@Cj[ǉ
	{
		CMenu *menu = NULL;
		if ((menu = pMenu->GetSubMenu(0)))
		{
			menu->AppendMenu(MF_BYCOMMAND|MF_SEPARATOR, 0, L"");

			int nIndex = 0;
			for (auto it = g_cfg.m_vecProfile.begin(); it != g_cfg.m_vecProfile.end(); ++it)
			{
				int nID = IDM_PROFILE_RANGE_START + nIndex;
				//CString csTmp;
				//csTmp.Format(L"%02d: %s", nIndex, it->wsName.c_str());
				menu->AppendMenu(MF_BYCOMMAND|MF_STRING, nID, it->wsName.c_str());

				if (nIndex == g_cfg.m_nProfileSelected)
				{
					menu->CheckMenuItem(nID, MF_CHECKED|MF_BYCOMMAND);
				}
				nIndex++;
			}
		}
	}

	/*
	//@vt@Cj[ǉ
	{
		int nIndex = 0;
		for (auto it = g_cfg.m_vecProfile.begin(); it != g_cfg.m_vecProfile.end(); ++it)
		{
			int nID = IDM_PROFILE_RANGE_START + nIndex;
			CString csTmp;
			csTmp.Format(L"%02d: %s", nIndex, it->wsName.c_str());
			pMenu->InsertMenu(IDM_REGISTER_PROFILE, MF_BYCOMMAND|MF_STRING, nID, csTmp);

			if (nIndex == g_cfg.m_nProfileSelected)
			{
				pMenu->CheckMenuItem(nID, MF_CHECKED|MF_BYCOMMAND);
			}
			nIndex++;
		}

		// Zp[^
		pMenu->InsertMenu(IDM_REGISTER_PROFILE, MF_BYCOMMAND|MF_SEPARATOR, 0, L"");
	}
	*/

	//@tB^Otǉ
	{
		int nIndex = 0;
		std::vector<CFilterGraph>::iterator it;
		for (it = m_Preview.m_vecGraph.begin(); it != m_Preview.m_vecGraph.end(); ++it)
		{
			int nID = IDM_FILTERGRAPH_RANGE_START + nIndex;
			pMenu->InsertMenu(IDM_FILTERGRAPH_INSERT_POINT, MF_BYCOMMAND|MF_STRING, nID, it->wsFriendlyName.c_str());

			if (it->bHasProperty != TRUE)
			{
				pMenu->EnableMenuItem(nID, MF_GRAYED|MF_BYCOMMAND);
			}

			nIndex++;
		}

		if (nIndex > 0)
		{
			pMenu->DeleteMenu(IDM_FILTERGRAPH_INSERT_POINT, MF_BYCOMMAND);
		}
	}


	CPreviewConfig preview = profile_.Preview;

	/*
	if (preview.bTransform)
	{
		pMenu->CheckMenuItem(IDM_TRANSFORM, MF_CHECKED|MF_BYCOMMAND);
	}
	*/


	if (preview.lTransformCopy == TRANSFORM_COPY_NONE)
	{
		pMenu->EnableMenuItem(IDM_TRANSFORM_FRAME_NONE, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_FRAME_HALF, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_FRAME_DOUBLE, MF_GRAYED|MF_BYCOMMAND);

		pMenu->EnableMenuItem(IDM_TRANSFORM_FIELD_ORDER_ODD, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_FIELD_ORDER_EVEN, MF_GRAYED|MF_BYCOMMAND);
	}


	switch (preview.lTransformCopy)
	{
	case TRANSFORM_COPY_SIMPLE:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_COPY_SIMPLE); break;

	case TRANSFORM_COPY_LINER:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_COPY_LINER); break;

	case TRANSFORM_COPY_LINER_SHARP:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_COPY_LINER_SHARP); break;

	case TRANSFORM_COPY_BLEND:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_COPY_BLEND); break;

	case TRANSFORM_COPY_BLEND_SHARP:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_COPY_BLEND_SHARP); break;

	case TRANSFORM_COPY_HARDWARE:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_COPY_HARDWARE); break;

	case TRANSFORM_COPY_NONE:
	default:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_COPY_NONE); break;
	}

	switch (preview.lTransformFrame)
	{
	case TRANSFORM_FRAME_HALF:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_FRAME_HALF); break;

	case TRANSFORM_FRAME_DOUBLE:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_FRAME_DOUBLE); break;

	case TRANSFORM_FRAME_NONE:
	default:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_FRAME_NONE); break;
	}

	switch (preview.lTransformFieldOrder)
	{
	case TRANSFORM_FIELD_ORDER_EVEN:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_FIELD_ORDER_EVEN); break;

	case TRANSFORM_FIELD_ORDER_ODD:
	default:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_FIELD_ORDER_ODD); break;
	}

	if (preview.bTransformFlipVertical)
	{
		pMenu->CheckMenuItem(IDM_TRANSFORM_FLIP_VERTICAL, MF_CHECKED|MF_BYCOMMAND);
	}

	switch (preview.lTransformYCExpand)
	{
	case TRANSFORM_YCEXPAND_UYVY:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_YCEXPAND_UYVY); break;

	case TRANSFORM_YCEXPAND_YUY2:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_YCEXPAND_YUY2); break;
		break;

	case TRANSFORM_YCEXPAND_NONE:
	default:
		CheckMenuRadio(pMenu, IDM_TRANSFORM_YCEXPAND_NONE); break;
	}

	// gXtH[tB^ɐڑł邩mF
	// rfItB^ڑĂȂƂ͗L
	BOOL bTransform = TRUE;
	try {

		if (profile_.Preview.bTransform)
		{
			std::vector<CFilterItem> vecFilter;
			std::vector<CFilterItem>::iterator it;

			vecFilter = profile_.Filter.vecVideo;

			for (it = vecFilter.begin(); it != vecFilter.end(); ++it)
			{
				if (it->bCheck)
				{
					//pMenu->EnableMenuItem(IDM_TRANSFORM, MF_GRAYED|MF_BYCOMMAND);
					bTransform = FALSE;
				}
			}
		}
		else
		{
			bTransform = FALSE;
		}

	} catch (std::exception const&) {}

	if (bTransform == FALSE)
	{
		pMenu->EnableMenuItem(IDM_TRANSFORM_COPY_NONE, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_COPY_SIMPLE, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_COPY_LINER, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_COPY_LINER_SHARP, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_COPY_BLEND, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_COPY_BLEND_SHARP, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_COPY_HARDWARE, MF_GRAYED|MF_BYCOMMAND);

		pMenu->EnableMenuItem(IDM_TRANSFORM_FIELD_ORDER_ODD, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_FIELD_ORDER_EVEN, MF_GRAYED|MF_BYCOMMAND);

		pMenu->EnableMenuItem(IDM_TRANSFORM_FRAME_NONE, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_FRAME_HALF, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_FRAME_DOUBLE, MF_GRAYED|MF_BYCOMMAND);

		pMenu->EnableMenuItem(IDM_TRANSFORM_YCEXPAND_NONE, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_YCEXPAND_UYVY, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_TRANSFORM_YCEXPAND_YUY2, MF_GRAYED|MF_BYCOMMAND);

		pMenu->EnableMenuItem(IDM_TRANSFORM_FLIP_VERTICAL, MF_GRAYED|MF_BYCOMMAND);
	}

	if (profile_.Preview.bAudioMute)
	{
		pMenu->CheckMenuItem(IDM_AUDIO_MUTE, MF_CHECKED|MF_BYCOMMAND);
	}

	long lProcessPriority = ASPECT_RATIO_INPUT;

	try {
		lProcessPriority = profile_.Preview.lProcessPriority;
	} catch (std::exception const&) {}

	switch (lProcessPriority)
	{
	case PROCESS_PRIORITY_REALTIME:
		pMenu->CheckMenuRadioItem(
			IDM_PROCESS_PRIORITY_REALTIME,
			IDM_PROCESS_PRIORITY_REALTIME,
			IDM_PROCESS_PRIORITY_REALTIME, MF_CHECKED|MF_BYCOMMAND);
		break;

	case PROCESS_PRIORITY_HIGH:
		pMenu->CheckMenuRadioItem(
			IDM_PROCESS_PRIORITY_HIGH,
			IDM_PROCESS_PRIORITY_HIGH,
			IDM_PROCESS_PRIORITY_HIGH, MF_CHECKED|MF_BYCOMMAND);
		break;

	case PROCESS_PRIORITY_ABOVE_NORMAL:
		pMenu->CheckMenuRadioItem(
			IDM_PROCESS_PRIORITY_ABOVE_NORMAL,
			IDM_PROCESS_PRIORITY_ABOVE_NORMAL,
			IDM_PROCESS_PRIORITY_ABOVE_NORMAL, MF_CHECKED|MF_BYCOMMAND);
		break;

	case PROCESS_PRIORITY_NORMAL:
		pMenu->CheckMenuRadioItem(
			IDM_PROCESS_PRIORITY_NORMAL,
			IDM_PROCESS_PRIORITY_NORMAL,
			IDM_PROCESS_PRIORITY_NORMAL, MF_CHECKED|MF_BYCOMMAND);
		break;

	case PROCESS_PRIORITY_BELOW_NOMAL:
		pMenu->CheckMenuRadioItem(
			IDM_PROCESS_PRIORITY_BELOW_NOMAL,
			IDM_PROCESS_PRIORITY_BELOW_NOMAL,
			IDM_PROCESS_PRIORITY_BELOW_NOMAL, MF_CHECKED|MF_BYCOMMAND);
		break;

	case PROCESS_PRIORITY_IDLE:
		pMenu->CheckMenuRadioItem(
			IDM_PROCESS_PRIORITY_IDLE,
			IDM_PROCESS_PRIORITY_IDLE,
			IDM_PROCESS_PRIORITY_IDLE, MF_CHECKED|MF_BYCOMMAND);
		break;

	default:
		pMenu->CheckMenuRadioItem(
			IDM_PROCESS_PRIORITY_NORMAL,
			IDM_PROCESS_PRIORITY_NORMAL,
			IDM_PROCESS_PRIORITY_NORMAL, MF_CHECKED|MF_BYCOMMAND);
		break;
	}

	long lAspectRatio = ASPECT_RATIO_INPUT;

	try {
		lAspectRatio = profile_.Preview.lAspectRatio;
	} catch (std::exception const&) {}

	switch (lAspectRatio)
	{
	case ASPECT_RATIO_INPUT:
		pMenu->CheckMenuRadioItem(
			IDM_ASPECT_RATIO_INPUT,
			IDM_ASPECT_RATIO_INPUT,
			IDM_ASPECT_RATIO_INPUT, MF_CHECKED|MF_BYCOMMAND);
		break;

	case ASPECT_RATIO_4_3:
		pMenu->CheckMenuRadioItem(
			IDM_ASPECT_RATIO_4_3,
			IDM_ASPECT_RATIO_4_3,
			IDM_ASPECT_RATIO_4_3, MF_CHECKED|MF_BYCOMMAND);
		break;

	case ASPECT_RATIO_16_9:
		pMenu->CheckMenuRadioItem(
			IDM_ASPECT_RATIO_16_9,
			IDM_ASPECT_RATIO_16_9,
			IDM_ASPECT_RATIO_16_9, MF_CHECKED|MF_BYCOMMAND);
		break;

	case ASPECT_RATIO_10_11:
		pMenu->CheckMenuRadioItem(
			IDM_ASPECT_RATIO_10_11,
			IDM_ASPECT_RATIO_10_11,
			IDM_ASPECT_RATIO_10_11, MF_CHECKED|MF_BYCOMMAND);
		break;

	case ASPECT_RATIO_40_33:
		pMenu->CheckMenuRadioItem(
			IDM_ASPECT_RATIO_40_33,
			IDM_ASPECT_RATIO_40_33,
			IDM_ASPECT_RATIO_40_33, MF_CHECKED|MF_BYCOMMAND);
		break;

	case ASPECT_RATIO_CUSTOM:
		pMenu->CheckMenuRadioItem(
			IDM_ASPECT_RATIO_CUSTOM,
			IDM_ASPECT_RATIO_CUSTOM,
			IDM_ASPECT_RATIO_CUSTOM, MF_CHECKED|MF_BYCOMMAND);
		break;


	case ASPECT_RATIO_WINDOW:
		pMenu->CheckMenuRadioItem(
			IDM_ASPECT_RATIO_WINDOW,
			IDM_ASPECT_RATIO_WINDOW,
			IDM_ASPECT_RATIO_WINDOW, MF_CHECKED|MF_BYCOMMAND);
		break;
	}

	// fg嗦
	{
		bool grayed = false;
		if (IsZoomed() || m_bFullScreen || !(m_Preview.IsVideoRenderer()))
		{
			grayed = true;
			//pMenu->EnableMenuItem(IDM_WINDOW_SIZE_ZOOM_100X, MF_GRAYED|MF_BYCOMMAND);
		}

		CMenu *menu = NULL;
		if ((menu = pMenu->GetSubMenu(6)))
		{
			menu->AppendMenu(MF_BYCOMMAND|MF_SEPARATOR, 0, L"");

			int index = 0;
			for (auto it = m_vecWindowZoom.begin(); it != m_vecWindowZoom.end(); ++it)
			{
				int id = IDM_WINDOWZOOM_RANGE_START + index;

				CString tmp;

				//if (index < 9)
				//{
				//	tmp.Format(L"%d%%\tCtrl+%d", it->zoom, index + 1);
				//}
				//else if (index == 9)
				//{
				//	tmp.Format(L"%d%%\tCtrl+0", it->zoom);
				//}
				//else
				//{
					tmp.Format(L"%d%%", it->zoom);
				//}
				menu->AppendMenu(MF_BYCOMMAND|MF_STRING, id, tmp);
				if (grayed)
				{
					menu->EnableMenuItem(id, MF_GRAYED|MF_BYCOMMAND);
				}

				index++;
			}
		}
	}

	// fTCY
	{
		bool grayed = false;
		if (IsZoomed() || m_bFullScreen)
		{
			grayed = true;
		}

		CMenu *menu = NULL;
		if ((menu = pMenu->GetSubMenu(7)))
		{
			menu->AppendMenu(MF_BYCOMMAND|MF_SEPARATOR, 0, L"");

			int index = 0;
			for (auto it = m_vecWindowSize.begin(); it != m_vecWindowSize.end(); ++it)
			{
				int id = IDM_WINDOWSIZE_RANGE_START + index;

				
				CString tmp;
				//if (index < 9)
				//{
				//	tmp.Format(L"%dx%d\tShift+%d", it->width, it->height, index+1);
				//}
				//else if (index == 9)
				//{
				//	tmp.Format(L"%dx%d\tShift+0", it->width, it->height);
				//}
				//else
				//{
					tmp.Format(L"%dx%d", it->width, it->height);
				//}

				menu->AppendMenu(MF_BYCOMMAND|MF_STRING, id, tmp);
				if (grayed)
				{
					menu->EnableMenuItem(id, MF_GRAYED|MF_BYCOMMAND);
				}

				index++;
			}
		}
	}

	if (IsZoomed() || m_bFullScreen || !(m_Preview.IsRun()))
	{
		pMenu->EnableMenuItem(IDM_WINDOW_SIZE_ZOOM_100X, MF_GRAYED|MF_BYCOMMAND);
	}


	if (m_bFullScreen)
	{
		pMenu->EnableMenuItem(IDM_VIEW_TITLEBAR, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_VIEW_WINDOW_FRAME, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_WINDOW_ASPECT_RATIO, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_VIEW_TOPMOST, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_WINDOW_SNAP, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_WINDOW_DRAG, MF_GRAYED|MF_BYCOMMAND);
	}
	else if (IsZoomed())
	{
		pMenu->EnableMenuItem(IDM_VIEW_TITLEBAR, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_VIEW_WINDOW_FRAME, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_WINDOW_ASPECT_RATIO, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_WINDOW_SNAP, MF_GRAYED|MF_BYCOMMAND);
		pMenu->EnableMenuItem(IDM_WINDOW_DRAG, MF_GRAYED|MF_BYCOMMAND);
	}

	if (g_cfg.m_bTitleBar)
	{
		pMenu->CheckMenuItem(IDM_VIEW_TITLEBAR, MF_CHECKED|MF_BYCOMMAND);
	}

	if (g_cfg.m_bWindowFrame)
	{
		pMenu->CheckMenuItem(IDM_VIEW_WINDOW_FRAME, MF_CHECKED|MF_BYCOMMAND);
	}
	else
	{
		// EBhEt[Ȃ̓^Cgo[ύXs
		pMenu->EnableMenuItem(IDM_VIEW_TITLEBAR, MF_GRAYED|MF_BYCOMMAND);
	}

	if (g_cfg.m_bWindowAspectRatio)
	{
		pMenu->CheckMenuItem(IDM_WINDOW_ASPECT_RATIO, MF_CHECKED|MF_BYCOMMAND);
	}


	if (g_cfg.m_bTopMost)
	{
		pMenu->CheckMenuItem(IDM_VIEW_TOPMOST, MF_CHECKED|MF_BYCOMMAND);
	}


	if (g_cfg.m_bWindowSnap)
	{
		pMenu->CheckMenuItem(IDM_WINDOW_SNAP, MF_CHECKED|MF_BYCOMMAND);
	}

	if (g_cfg.m_bWindowDrag)
	{
		pMenu->CheckMenuItem(IDM_WINDOW_DRAG, MF_CHECKED|MF_BYCOMMAND);
	}

	if (g_cfg.m_bScreenSaverStop)
	{
		pMenu->CheckMenuItem(IDM_SCREEN_SAVER_STOP, MF_CHECKED|MF_BYCOMMAND);
	}

	if (g_cfg.m_bMonitorPowerOffStop)
	{
		pMenu->CheckMenuItem(IDM_MONITOR_POWER_OFF_STOP, MF_CHECKED|MF_BYCOMMAND);
	}

	if (g_cfg.m_bSystemStandbyStop)
	{
		pMenu->CheckMenuItem(IDM_SYSTEM_STANBY_STOP, MF_CHECKED|MF_BYCOMMAND);
	}

	// VideoProcAmp
	if (!(m_Preview.IsVideoRenderer()))
	{
		pMenu->EnableMenuItem(IDM_VIDEO_PROC_AMP, MF_GRAYED|MF_BYCOMMAND);
	}

	// VMR9ProcAmp
	if (!(m_Preview.IsVideoRenderer()) || preview.lVideoRenderer != VIDEO_RENDERER_VMR9)
	{
		pMenu->EnableMenuItem(IDM_VMR9_PROC_AMP, MF_GRAYED|MF_BYCOMMAND);
	}

	// EVRProcAmp
	if (!(m_Preview.IsVideoRenderer()) ||
		(preview.lVideoRenderer != VIDEO_RENDERER_EVR && preview.lVideoRenderer != VIDEO_RENDERER_EVR_CUSTOM))
	{
		pMenu->EnableMenuItem(IDM_EVR_PROC_AMP, MF_GRAYED|MF_BYCOMMAND);
	}


	// XibvVbg
	if (!(m_Preview.IsVideoRenderer()))
	{
		pMenu->EnableMenuItem(IDM_SNAPSHOT, MF_GRAYED|MF_BYCOMMAND);
		//pMenu->EnableMenuItem(IDM_SNAPSHOT_FOLDER, MF_GRAYED|MF_BYCOMMAND);
		//pMenu->EnableMenuItem(IDM_SNAPSHOT_CONFIG, MF_GRAYED|MF_BYCOMMAND);
	}

	if (m_bFullScreen)
	{
		pMenu->EnableMenuItem(IDM_SNAPSHOT_FOLDER, MF_GRAYED|MF_BYCOMMAND);
	}





	pMenu->TrackPopupMenu(TPM_LEFTBUTTON, pt.x, pt.y, this);

	cMenu.DestroyMenu();


	if (m_bFullScreen)
	{
		StartMouseHideTimer();
	}

	CDialog::OnRButtonUp(nFlags, point);
}





void CMainDlg::OnDebug01()
{
#ifdef _DEBUG
	if (m_bFullScreen)
	{
		EndMouseHideTimer();
	}

	CInnerFilterSheet dlg(this, &profile_, L"tB^ݒ", this);
	dlg.SetLastTab(g_cfg.m_nOptionLastTab);

	if (dlg.DoModal() == IDOK)
	{
	
	}

	g_cfg.m_nOptionLastTab = dlg.GetLastTab();


	if (m_bFullScreen)
	{
		StartMouseHideTimer();
	}
#endif
}


void CMainDlg::OnDebug02()
{
#ifdef _DEBUG
	if (m_bFullScreen) { EndMouseHideTimer(); }

	CShortCutDlg dlg;
	dlg.SetShortCut(g_cfg.m_vecShortCut);
	if (dlg.DoModal() == IDOK)
	{
		dlg.GetShortCut(g_cfg.m_vecShortCut);
	}

	if (m_bFullScreen) { StartMouseHideTimer(); }
#endif
}


LRESULT CMainDlg::OnGraphNotify(WPARAM wParam, LPARAM lParam)
{
	long evCode;
	LONG param1, param2;

	// CxgSĎ擾
	while (m_Preview.GetEvent(&evCode, &param1, &param2))
	{
	
		switch (evCode)
		{
		case EC_COMPLETE:
			{// ĐI
				//MessageBox(L"EC_COMPLETE");
				break;
			}
		case EC_ACTIVATE:
			{
				//MessageBox(L"EC_ACTIVATE");
				break;
			}
		case EC_VIDEO_SIZE_CHANGED:
			{
				//CString csTmp;
				//csTmp.Format(L"EC_VIDEO_SIZE_CHANGED(%d, %d)", LOWORD(param1), HIWORD(param1));
				//MessageBox(csTmp);
				break;
			}
		default:
			{
				break;
			}
		}
	}

	return NOERROR;
}

void CMainDlg::ResizeWindow()
{
	m_Preview.SetVideoPosition();
	ChangeCaption();
}

void CMainDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	ResizeWindow();
}

BOOL CMainDlg::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
/*
	CRect rc;
	GetClientRect(&rc);
	pDC->FillSolidRect(&rc, RGB(0,0,0));    // 
*/
	return TRUE;
//	return CDialog::OnEraseBkgnd(pDC);
}

void CMainDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (!g_cfg.m_bWindowFrame && !IsZoomed() && !m_bFullScreen)
	{ // EBhEt[Ƃ̓TCYύX
		int nPos = GetFramePos(point);

		switch (nPos)
		{
		case FRAMEPOS_TOP:
			PostMessage(WM_SYSCOMMAND, SC_SIZE|WMSZ_TOP,0);
			::SetCursor(LoadCursor(NULL, IDC_SIZENS));
			break;

		case FRAMEPOS_BOTTOM:
			PostMessage(WM_SYSCOMMAND, SC_SIZE|WMSZ_BOTTOM,0);
			::SetCursor(LoadCursor(NULL, IDC_SIZENS));
			break;

		case FRAMEPOS_TOPLEFT:
			PostMessage(WM_SYSCOMMAND, SC_SIZE|WMSZ_TOPLEFT,0);
			::SetCursor(LoadCursor(NULL, IDC_SIZENWSE));
			break;

		case FRAMEPOS_BOTTOMRIGHT:
			PostMessage(WM_SYSCOMMAND, SC_SIZE|WMSZ_BOTTOMRIGHT,0);
			::SetCursor(LoadCursor(NULL, IDC_SIZENWSE));
			break;

		case FRAMEPOS_TOPRIGHT:
			PostMessage(WM_SYSCOMMAND, SC_SIZE|WMSZ_TOPRIGHT,0);
			::SetCursor(LoadCursor(NULL, IDC_SIZENESW));
			break;

		case FRAMEPOS_BOTTOMLEFT:
			PostMessage(WM_SYSCOMMAND, SC_SIZE|WMSZ_BOTTOMLEFT,0);
			::SetCursor(LoadCursor(NULL, IDC_SIZENESW));
			break;

		case FRAMEPOS_LEFT:
			PostMessage(WM_SYSCOMMAND, SC_SIZE|WMSZ_LEFT,0);
			::SetCursor(LoadCursor(NULL, IDC_SIZEWE));
			break;

		case FRAMEPOS_RIGHT:
			PostMessage(WM_SYSCOMMAND, SC_SIZE|WMSZ_RIGHT,0);
			::SetCursor(LoadCursor(NULL, IDC_SIZEWE));
			break;

		default:
			{
				CPoint pt(point);
				GetCursorPos(&pt);

				CRect rc;
				GetWindowRect(&rc);

				m_ptWindowDrag.x = pt.x - rc.left;
				m_ptWindowDrag.y = pt.y - rc.top;

				m_bWindowDragFlag = TRUE;
				SetCapture();
			}
			break;
		}
	}
	else if (!IsZoomed() && !m_bFullScreen)
	{	// tXN[̎̓EBhEhbOȂ
		CPoint pt(point);
		GetCursorPos(&pt);

		CRect rc;
		GetWindowRect(&rc);

		m_ptWindowDrag.x = pt.x - rc.left;
		m_ptWindowDrag.y = pt.y - rc.top;

		m_bWindowDragFlag = TRUE;
		SetCapture();
	}

	CDialog::OnLButtonDown(nFlags, point);
}


void CMainDlg::OnLButtonUp(UINT nFlags, CPoint point)
{

	m_bWindowDragFlag = FALSE;

	ReleaseCapture();

	/*
	if (!IsZoomed() && !m_bFullScreen && g_cfg.m_bWindowSnap)
	{
		CRect rcDesktop, rcClient;

		if (GetDesktopRectFromWindow(GetSafeHwnd(), rcDesktop))
		{
			int nSnap = 10;

			GetWindowRect(&rcClient);
			if (rcClient.left < (rcDesktop.left + nSnap) && rcClient.left > (rcDesktop.left - nSnap))
			{
				SetWindowPos(NULL, rcDesktop.left, rcClient.top, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
			}

			GetWindowRect(&rcClient);
			if (rcClient.right > (rcDesktop.right - nSnap) && rcClient.right < (rcDesktop.right + nSnap))
			{
				SetWindowPos(NULL, rcDesktop.right - rcClient.Width(), rcClient.top, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
			}

			GetWindowRect(&rcClient);
			if (rcClient.top < (rcDesktop.top + nSnap) && rcClient.top > (rcDesktop.top - nSnap))
			{
				SetWindowPos(NULL, rcClient.left, rcDesktop.top, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
			}

			GetWindowRect(&rcClient);
			if (rcClient.bottom > (rcDesktop.bottom - nSnap) && rcClient.bottom < (rcDesktop.bottom + nSnap))
			{
				SetWindowPos(NULL, rcClient.left, rcDesktop.bottom - rcClient.Height(), 0, 0, SWP_NOSIZE|SWP_NOZORDER);
			}
		}
	}
	*/
	CDialog::OnLButtonUp(nFlags, point);
}




void CMainDlg::OnLButtonDblClk(UINT nFlags, CPoint point)
{

	ToggleFullScreen();


	CDialog::OnLButtonDblClk(nFlags, point);
}

BOOL CMainDlg::ToggleFullScreen(void)
{
	if (IsZoomed())
	{
		ShowWindow(SW_RESTORE);
		return m_bFullScreen;
	}

	if (m_bFullScreen)
	{
		// EBhEX^CύX
		if (g_cfg.m_bWindowFrame)
		{
			if (g_cfg.m_bTitleBar)
			{
				ModifyStyle(0, WS_CAPTION|WS_THICKFRAME, 0);
			}
			else
			{
				ModifyStyle(0, WS_THICKFRAME, 0);
			}
		}

		// őOʉƃX^CύX̓Kp
		if (g_cfg.m_bTopMost)
		{
			SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_FRAMECHANGED);
		}
		else
		{
			SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_FRAMECHANGED);
		}

		// EBhEʒu
		SetWindowPlacement(&m_stWndRestore);

		UpdateWindow();

		m_bFullScreen = FALSE;

		if (g_cfg.m_bWindowAspectRatio && !IsZoomed())
		{
			NoMoveApplyWindowAspectRatioSize();
		}

		EndMouseHideTimer();
	}
	else
	{	// tXN[
		// tXN[ÕEBhEʒuۑ
		::ZeroMemory(&m_stWndRestore, sizeof(WINDOWPLACEMENT));
		m_stWndRestore.length = sizeof(WINDOWPLACEMENT);
		if (GetWindowPlacement(&m_stWndRestore))
		{
			// EBhEX^CύX
			if (g_cfg.m_bWindowFrame)
			{
				if (g_cfg.m_bTitleBar)
				{
					ModifyStyle(WS_CAPTION|WS_THICKFRAME, 0, 0);
				}
				else
				{
					ModifyStyle(WS_THICKFRAME, 0, 0);
				}
			}

			// EBhEfXNgbvTCY
			POINT pt;
			if (::GetCursorPos(&pt))
			{
				RECT rcDesktop;
				if (GetDesktopRectFromPoint(pt, rcDesktop))
				{
					MoveWindow(&rcDesktop);

					// őOʉƃX^CύX̓Kp
					SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_FRAMECHANGED);
					UpdateWindow();

					m_bFullScreen = TRUE;

					StartMouseHideTimer();
				}
			}
		}
	}

	return m_bFullScreen;
}


//---------------------------------------------------------------------------------------
// vt@Cݒ
void CMainDlg::OnRegisterProfile()
{
	if (m_bFullScreen) { EndMouseHideTimer(); }

	OnPreviewStop();

	CProfileMainDlg dlg;

	// Jgvt@Cۑ
	try {
		g_cfg.m_vecProfile.at(g_cfg.m_nProfileSelected) = profile_;
	}
	catch (std::exception const&) {}

	// ݒKp
	dlg.m_nLastTab = g_cfg.m_nProfileLastTab;
	dlg.m_bPreview = g_cfg.m_bProfilePreview;
	dlg.Init(g_cfg.m_nProfileSelected, g_cfg.m_vecProfile);

	if (dlg.DoModal() == IDOK)
	{
		// ݒǂݍ
		g_cfg.m_nProfileLastTab = dlg.m_nLastTab;
		g_cfg.m_nProfileSelected = dlg.m_nSelected;
		g_cfg.m_bProfilePreview = dlg.m_bPreview;
		g_cfg.m_vecProfile = dlg.m_vecProfile;

		// vt@Co
		if (!g_cfg.m_bMultiBoot)
		{
			g_cfg.SaveProfile();
		}

		// Jgvt@Cݒ
		try {
			profile_ = g_cfg.m_vecProfile.at(g_cfg.m_nProfileSelected);
		}
		catch (std::exception const&) {}

		// vr[
		if (g_cfg.m_bProfilePreview)
		{
			OnPreviewBuild();
		}
	}

	g_cfg.m_nProfileLastTab = dlg.m_nLastTab;

	if (m_bFullScreen) { StartMouseHideTimer(); }

	return;
}

void CMainDlg::OnSelectProfile(UINT nID)
{
	m_Preview.GetVideoProcAmpConfig(profile_.VideoProcAmp);

	int nSelected = nID - IDM_PROFILE_RANGE_START;

	// Jgvt@Cۑ
	try {
		g_cfg.m_vecProfile.at(g_cfg.m_nProfileSelected) = profile_;
		profile_ = g_cfg.m_vecProfile.at(nSelected);
	}
	catch (std::exception const&) { FAILED_TRACE; }

	g_cfg.m_nProfileSelected = nSelected;

	OnPreviewBuild();
}

void CMainDlg::OnSelectFilterGraph(UINT nID)
{
	if (m_bFullScreen)
	{
		EndMouseHideTimer();
	}

	int nIndex = nID - IDM_FILTERGRAPH_RANGE_START;
	m_Preview.ShowFilterProperty(nIndex);

	if (m_bFullScreen)
	{
		StartMouseHideTimer();
	}
}


//---------------------------------------------------------------------------------------
// tB^gp
void CMainDlg::OnTransform()
{
	ShowInnerFilterDlg(5);
	/*
	try {
		BOOL bTransform = TRUE;
		bTransform = profile_.Preview.bTransform;
		profile_.Preview.bTransform = bTransform ? FALSE : TRUE;
	} catch (std::exception const&) { FAILED_TRACE; }

	OnPreviewIsRunBuild();
	*/
}

//---------------------------------------------------------------------------------------
// fC^[[X
/*
		// K؂FPS֕ύX
		switch (lTransformCopy)
		{
		case TRANSFORM_COPY_SIMPLE:
		case TRANSFORM_COPY_LINER:
		case TRANSFORM_COPY_LINER_SHARP:
		case TRANSFORM_COPY_BLEND:
		case TRANSFORM_COPY_BLEND_SHARP:
			lFrame = TRANSFORM_FRAME_DOUBLE;
			profile_.Preview.lTransformFrame = lFrame;
			m_Preview.SetTransformFrame(lFrame);
			break;

		case TRANSFORM_COPY_HARDWARE:
		case TRANSFORM_COPY_NONE:
		default:
			lFrame = TRANSFORM_FRAME_NONE;
			profile_.Preview.lTransformFrame = lFrame;
			m_Preview.SetTransformFrame(lFrame);
			break;
		}
*/

BOOL CMainDlg::SetTransformCopy(long lTransformCopy)
{
	long lFrame = TRANSFORM_FRAME_NONE;
	long lCopy = TRANSFORM_COPY_NONE;
	m_Preview.SetTransformCopy(lTransformCopy);

	if (lTransformCopy == TRANSFORM_COPY_NONE)
	{// Rs[̓t[[g𓙔{ɕύX
		profile_.Preview.lTransformFrame = TRANSFORM_FRAME_NONE;
	}
	else
	{// Rs[ȊO̓t[[g2{ɕύX
		profile_.Preview.lTransformFrame = TRANSFORM_FRAME_DOUBLE;
	}
	// t[[gKp
	m_Preview.SetTransformFrame(profile_.Preview.lTransformFrame);


	lCopy = profile_.Preview.lTransformCopy;
	profile_.Preview.lTransformCopy = lTransformCopy;

	if (lCopy != lTransformCopy &&
		(lCopy == TRANSFORM_COPY_HARDWARE || lTransformCopy == TRANSFORM_COPY_HARDWARE))
	{
		// ǂ炩n[hEFAȂ烊rh
		OnPreviewIsRunBuild();
	}

	return TRUE;
}

void CMainDlg::OnTransformCopyNone()
{
	SetTransformCopy(TRANSFORM_COPY_NONE);
}

void CMainDlg::OnTransformCopySimple()
{
	SetTransformCopy(TRANSFORM_COPY_SIMPLE);
}

void CMainDlg::OnTransformCopyLiner()
{
	SetTransformCopy(TRANSFORM_COPY_LINER);
}

void CMainDlg::OnTransformCopyLinerSharp()
{
	SetTransformCopy(TRANSFORM_COPY_LINER_SHARP);
}

void CMainDlg::OnTransformCopyBlend()
{
	SetTransformCopy(TRANSFORM_COPY_BLEND);
}

void CMainDlg::OnTransformCopyBlendSharp()
{
	SetTransformCopy(TRANSFORM_COPY_BLEND_SHARP);
}

void CMainDlg::OnTransformCopyHardware()
{
	SetTransformCopy(TRANSFORM_COPY_HARDWARE);
}

//---------------------------------------------------------------------------------------
// t[[g
BOOL CMainDlg::SetTransformFrame(long lTransformFrame)
{
	long lFrame = TRANSFORM_FRAME_NONE;
	long lCopy = TRANSFORM_COPY_NONE;
	m_Preview.SetTransformFrame(lTransformFrame);

	lCopy = profile_.Preview.lTransformCopy;
	lFrame = profile_.Preview.lTransformFrame;
	profile_.Preview.lTransformFrame = lTransformFrame;

	if (lCopy == TRANSFORM_COPY_HARDWARE && // n[hEFA
		lFrame != lTransformFrame && // ǂ炩2{Ȃ烊rh
		(lFrame == TRANSFORM_FRAME_DOUBLE || lTransformFrame == TRANSFORM_FRAME_DOUBLE))
	{
		OnPreviewIsRunBuild();
	}

	return TRUE;
}


void CMainDlg::OnTransformFrameNone()
{
	SetTransformFrame(TRANSFORM_FRAME_NONE);
}

void CMainDlg::OnTransformFrameHalf()
{
	SetTransformFrame(TRANSFORM_FRAME_HALF);
}

void CMainDlg::OnTransformFrameDouble()
{
	SetTransformFrame(TRANSFORM_FRAME_DOUBLE);
}

//---------------------------------------------------------------------------------------
// tB[hI[_[
BOOL CMainDlg::SetTransformFieldOrder(long lTransformFieldOrder)
{
	long lCopy = TRANSFORM_COPY_NONE;
	m_Preview.SetTransformFieldOrder(lTransformFieldOrder);
	try {
		lCopy = profile_.Preview.lTransformCopy;
		profile_.Preview.lTransformFieldOrder = lTransformFieldOrder;
/*
		if (lCopy == TRANSFORM_COPY_HARDWARE)
		{
			// n[hEFAȂ烊rh
			OnPreviewIsRunBuild();
		}
		return TRUE;
*/
	} catch (std::exception const&) { FAILED_TRACE; }
	return FALSE;
}

void CMainDlg::OnTransformFieldOrderOdd()
{
	SetTransformFieldOrder(TRANSFORM_FIELD_ORDER_ODD);
}

void CMainDlg::OnTransformFieldOrderEven()
{
	SetTransformFieldOrder(TRANSFORM_FIELD_ORDER_EVEN);
}


//---------------------------------------------------------------------------------------
// ㉺]
void CMainDlg::OnTransformFlipVertical()
{
	BOOL bFlip = FALSE;
	try {
		bFlip = profile_.Preview.bTransformFlipVertical;
		bFlip = bFlip ? FALSE : TRUE;
		profile_.Preview.bTransformFlipVertical = bFlip;
	} catch (std::exception const&) { FAILED_TRACE; }

	m_Preview.SetTransformFlipVertical(bFlip);
}

//---------------------------------------------------------------------------------------
// YCL
void CMainDlg::OnTransformYcexpandNone()
{
	m_Preview.SetTransformYCExpand(TRANSFORM_YCEXPAND_NONE);
	try {
		profile_.Preview.lTransformYCExpand = TRANSFORM_YCEXPAND_NONE;
	} catch (std::exception const&) { FAILED_TRACE; }
}

void CMainDlg::OnTransformYcexpandUyvy()
{
	m_Preview.SetTransformYCExpand(TRANSFORM_YCEXPAND_UYVY);
	try {
		profile_.Preview.lTransformYCExpand = TRANSFORM_YCEXPAND_UYVY;
	} catch (std::exception const&) { FAILED_TRACE; }
}

void CMainDlg::OnTransformYcexpandYuv2()
{
	m_Preview.SetTransformYCExpand(TRANSFORM_YCEXPAND_YUY2);
	try {
		profile_.Preview.lTransformYCExpand = TRANSFORM_YCEXPAND_YUY2;
	} catch (std::exception const&) { FAILED_TRACE; }
}

//---------------------------------------------------------------------------------------
// tB^ݒ

void CMainDlg::OnRenderer()
{
	ShowInnerFilterDlg(0);
}


//---------------------------------------------------------------------------------------
// tB^_CAO\

void CMainDlg::ShowInnerFilterDlg(int tab)
{
	if (m_bFullScreen) { EndMouseHideTimer(); }

	CInnerFilterSheet dlg(this, &profile_, L"IvV", this);
	dlg.SetLastTab(tab);

	if (dlg.DoModal() == IDOK)
	{
	
	}

	g_cfg.m_nOptionLastTab = dlg.GetLastTab();

	if (m_bFullScreen) { StartMouseHideTimer(); }
}


//---------------------------------------------------------------------------------------
// vr[Rg[
void CMainDlg::OnPreviewIsRunBuild()
{
	if (m_Preview.IsRun())
	{
		OnPreviewBuild();
	}
}

void CMainDlg::OnPreviewRun()
{
	if (!(m_Preview.IsRun()))
	{
		OnPreviewBuild();
	}
}

void CMainDlg::OnPreviewStop()
{
	if (m_Preview.IsRun())
	{
		if (g_cfg.m_bSystemStandbyStop)
		{
			SetThreadExecutionState(ES_CONTINUOUS);
		}

		m_Preview.Stop();
		m_Preview.UnInit();
		Invalidate();
	}
}

void CMainDlg::OnPreviewBuild()
{
	m_Preview.UnInit();
	m_Preview.Init();
	if (!m_Preview.Preview(GetSafeHwnd(), profile_))
	{
		m_Preview.UnInit();
		Invalidate();

		m_Preview.AddLog(L"tB^Ot̍\zɎs܂");
		MessageBox(m_Preview.GetLog(), NULL, MB_ICONEXCLAMATION|MB_OK);
		//OnRegisterProfile();
		return;
	}

	// X^oC}~
	if (g_cfg.m_bSystemStandbyStop && m_Preview.IsRun())
	{
		SetThreadExecutionState(ES_SYSTEM_REQUIRED|ES_CONTINUOUS);
	}

	// sDx
	long lProcessPriority = PROCESS_PRIORITY_ABOVE_NORMAL;
	try {
		lProcessPriority = profile_.Preview.lProcessPriority;
	} catch (std::exception const&) {}
	SetProcessPriority(lProcessPriority);


	// AXyNgŒEBhE
	if (g_cfg.m_bWindowAspectRatio && !IsZoomed() && !m_bFullScreen)
	{
		NoMoveApplyWindowAspectRatioSize();
	}

	ResizeWindow();
}




//---------------------------------------------------------------------------------------
// vZXDx
void CMainDlg::OnProcessPriorityRealtime()
{
	try {
		profile_.Preview.lProcessPriority = PROCESS_PRIORITY_REALTIME;
	} catch (std::exception const&) {}
	SetProcessPriority(PROCESS_PRIORITY_REALTIME);
}

void CMainDlg::OnProcessPriorityHigh()
{
	try {
		profile_.Preview.lProcessPriority = PROCESS_PRIORITY_HIGH;
	} catch (std::exception const&) {}
	SetProcessPriority(PROCESS_PRIORITY_HIGH);
}

void CMainDlg::OnProcessPriorityAboveNormal()
{
	try {
		profile_.Preview.lProcessPriority = PROCESS_PRIORITY_ABOVE_NORMAL;
	} catch (std::exception const&) {}
	SetProcessPriority(PROCESS_PRIORITY_ABOVE_NORMAL);
}

void CMainDlg::OnProcessPriorityNormal()
{
	try {
		profile_.Preview.lProcessPriority = PROCESS_PRIORITY_NORMAL;
	} catch (std::exception const&) {}
	SetProcessPriority(PROCESS_PRIORITY_NORMAL);
}

void CMainDlg::OnProcessPriorityBelowNomal()
{
	try {
		profile_.Preview.lProcessPriority = PROCESS_PRIORITY_BELOW_NOMAL;
	} catch (std::exception const&) {}
	SetProcessPriority(PROCESS_PRIORITY_BELOW_NOMAL);
}

void CMainDlg::OnProcessPriorityIdle()
{
	try {
		profile_.Preview.lProcessPriority = PROCESS_PRIORITY_IDLE;
	} catch (std::exception const&) {}
	SetProcessPriority(PROCESS_PRIORITY_IDLE);
}

BOOL CMainDlg::SetProcessPriority(long lPriority)
{
	BOOL bResult = FALSE;
	HANDLE hProcess = ::GetCurrentProcess();	// [nhԂ CloseHandle KvȂ

	switch (lPriority)
	{
	case PROCESS_PRIORITY_NORMAL:
		bResult = ::SetPriorityClass(hProcess, NORMAL_PRIORITY_CLASS);
		break;

	case PROCESS_PRIORITY_BELOW_NOMAL:
		bResult = ::SetPriorityClass(hProcess, BELOW_NORMAL_PRIORITY_CLASS);
		break;

	case PROCESS_PRIORITY_IDLE:
		bResult = ::SetPriorityClass(hProcess, IDLE_PRIORITY_CLASS);
		break;

	case PROCESS_PRIORITY_ABOVE_NORMAL:
		bResult = ::SetPriorityClass(hProcess, ABOVE_NORMAL_PRIORITY_CLASS);
		break;

	case PROCESS_PRIORITY_HIGH:
		bResult = ::SetPriorityClass(hProcess, HIGH_PRIORITY_CLASS);
		break;

	case PROCESS_PRIORITY_REALTIME:
		bResult = ::SetPriorityClass(hProcess, REALTIME_PRIORITY_CLASS);
		break;

	default:
		break;
	}

	return bResult;
}


//---------------------------------------------------------------------------------------
// \ݒ
void CMainDlg::OnViewTitlebar()
{
	if (IsZoomed() || m_bFullScreen || !g_cfg.m_bWindowFrame)
	{
		return;
	}

	int nCYCaption = GetSystemMetrics(SM_CYCAPTION);
	int nCXBorder = GetSystemMetrics(SM_CXBORDER);
	int nCYBorder = GetSystemMetrics(SM_CYBORDER);
	CRect rc;

	GetWindowRect(&rc);


	if (g_cfg.m_bTitleBar)
	{
		// ^Cgo[
		rc.DeflateRect(0, nCYCaption, 0, 0);
		rc.DeflateRect(nCXBorder, nCYBorder);
		SetWindowPos(NULL, rc.left, rc.top, rc.Width(), rc.Height(), SWP_NOZORDER);

		ModifyStyle(WS_CAPTION, 0);
		SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_FRAMECHANGED);

		g_cfg.m_bTitleBar = FALSE;
	}
	else
	{
		rc.InflateRect(0, nCYCaption, 0, 0);
		rc.InflateRect(nCXBorder, nCYBorder);
		SetWindowPos(NULL, rc.left, rc.top, rc.Width(), rc.Height(), SWP_NOZORDER);

		ModifyStyle(0, WS_CAPTION);
		SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_FRAMECHANGED);

		g_cfg.m_bTitleBar = TRUE;
	}
}

void CMainDlg::OnViewWindowFrame()
{
	if (IsZoomed() || m_bFullScreen)
	{
		return;
	}

	int nCYCaption = GetSystemMetrics(SM_CYCAPTION);
	int nCXFrame = GetSystemMetrics(SM_CXFRAME);
	int nCYFrame = GetSystemMetrics(SM_CYFRAME);
	int nCXBorder = GetSystemMetrics(SM_CXBORDER);
	int nCYBorder = GetSystemMetrics(SM_CYBORDER);

	CRect rc;

	GetWindowRect(&rc);

	if (g_cfg.m_bWindowFrame)
	{
		// EBhEg
		if (g_cfg.m_bTitleBar)
		{
			rc.DeflateRect(0, nCYCaption, 0, 0);
			rc.DeflateRect(nCXFrame, nCYFrame);
			SetWindowPos(NULL, rc.left, rc.top, rc.Width(), rc.Height(), SWP_NOZORDER);

			ModifyStyle(WS_CAPTION|WS_THICKFRAME, 0);
			SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_FRAMECHANGED);
		}
		else
		{
			rc.DeflateRect(nCXFrame - nCXBorder, nCYFrame - nCYBorder);
			SetWindowPos(NULL, rc.left, rc.top, rc.Width(), rc.Height(), SWP_NOZORDER);

			ModifyStyle(WS_CAPTION|WS_THICKFRAME, 0);
			SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_FRAMECHANGED);
		}
		
		//SetWindowPos(NULL, rc.left, rc.top, rc.Width(), rc.Height(), SWP_FRAMECHANGED);

		g_cfg.m_bWindowFrame = FALSE;
	}
	else
	{
		if (g_cfg.m_bTitleBar)
		{
			rc.InflateRect(0, nCYCaption, 0, 0);
			rc.InflateRect(nCXFrame, nCYFrame);
			SetWindowPos(NULL, rc.left, rc.top, rc.Width(), rc.Height(), SWP_NOZORDER);

			ModifyStyle(0, WS_CAPTION|WS_THICKFRAME);
			SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_FRAMECHANGED);
		}
		else
		{
			rc.InflateRect(nCXFrame - nCXBorder, nCYFrame - nCYBorder);
			SetWindowPos(NULL, rc.left, rc.top, rc.Width(), rc.Height(), SWP_NOZORDER);

			ModifyStyle(WS_CAPTION, WS_THICKFRAME);
			SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_FRAMECHANGED);
		}

		//SetWindowPos(NULL, rc.left, rc.top, rc.Width(), rc.Height(), SWP_FRAMECHANGED);

		g_cfg.m_bWindowFrame = TRUE;
	}
}

void CMainDlg::OnViewTopmost()
{
	if (IsZoomed() || m_bFullScreen)
	{
		return;
	}

	if (g_cfg.m_bTopMost)
	{
		// ɎO
		SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
		g_cfg.m_bTopMost = FALSE;
	}
	else
	{
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
		g_cfg.m_bTopMost = TRUE;
	}
}


//---------------------------------------------------------------------------------------
// XVpɒIɃEBhEbZ[W𓊂^C}[
void CMainDlg::StartCaptionTimer(void)
{
	SetTimer(TIMER_ID_CAPTION, 1000, NULL);
}

void CMainDlg::EndCaptionTimer(void)
{
	KillTimer(TIMER_ID_CAPTION);
}


void CMainDlg::ChangeCaption(void)
{
	int fps = 0, drop = 0;
	m_Preview.GetQualProp(&fps, &drop);

	CRect rc;
	GetClientRect(&rc);

	std::wstring wsProfile;
	int nVolume = 0;
	BOOL bMute = FALSE;
	try {
		wsProfile = profile_.wsName;
		nVolume = profile_.Preview.nAudioVolume;
		bMute = profile_.Preview.bAudioMute;
	} catch(std::exception const&) {}

	CString csTmp;
	if (bMute)
	{
		csTmp.Format(L"%s [%dx%d %4.2ffps] (---) - PeCaTV2", wsProfile.c_str(), rc.Width(), rc.Height(), (double)fps / 100.0, nVolume);
	}
	else
	{
		csTmp.Format(L"%s [%dx%d %4.2ffps] (%d) - PeCaTV2", wsProfile.c_str(), rc.Width(), rc.Height(), (double)fps / 100.0, nVolume);
	}
	SetWindowText(csTmp);
}

//---------------------------------------------------------------------------------------
// tXN[̃}EXp^C}[
void CMainDlg::StartMouseHideTimer(void)
{
	SetTimer(TIMER_ID_MOUSE_HIDE, 1000, NULL);
	while (ShowCursor(TRUE) < 0); // \܂Ń[v
}

void CMainDlg::EndMouseHideTimer(void)
{
	KillTimer(TIMER_ID_MOUSE_HIDE);
	while (ShowCursor(TRUE) < 0); // \܂Ń[v
}


void CMainDlg::OnTimer(UINT_PTR nIDEvent)
{
	switch (nIDEvent)
	{
	case TIMER_ID_CAPTION:
		ChangeCaption();
		break;

	case TIMER_ID_MOUSE_HIDE:
		while(ShowCursor(FALSE) >= 0); // J[\̔\
		break;
	}

	CDialog::OnTimer(nIDEvent);
}




void CMainDlg::OnQuit()
{
	PostMessage(WM_CLOSE);
}

void CMainDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	if (m_bFullScreen)
	{
		StartMouseHideTimer();
	}

	if (!IsZoomed() && !m_bFullScreen && g_cfg.m_bWindowDrag && m_bWindowDragFlag)
	{
		// EBhEhbO tXN[ɃEBhEhbOtOLȂ
	
		CPoint pt(point);

		pt.x -= m_ptWindowDrag.x;
		pt.y -= m_ptWindowDrag.y;

		ClientToScreen(&pt);

		if (g_cfg.m_bWindowSnap) // EBhEXibv
		{
			setWindowSnap(GetSafeHwnd(), &pt);
		}
		else
		{
			SetWindowPos(NULL, pt.x, pt.y, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
		}
	}

	if (!g_cfg.m_bWindowFrame && !IsZoomed() && !m_bFullScreen)
	{ // EBhEt[Ƃ̓TCYύXpJ[\\
		int nPos = GetFramePos(point);

		switch (nPos)
		{
		case FRAMEPOS_TOP:
		case FRAMEPOS_BOTTOM:
			::SetCursor(LoadCursor(NULL, IDC_SIZENS));
			break;

		case FRAMEPOS_TOPLEFT:
		case FRAMEPOS_BOTTOMRIGHT:
			::SetCursor(LoadCursor(NULL, IDC_SIZENWSE));
			break;

		case FRAMEPOS_TOPRIGHT:
		case FRAMEPOS_BOTTOMLEFT:
			::SetCursor(LoadCursor(NULL, IDC_SIZENESW));
			break;

		case FRAMEPOS_LEFT:
		case FRAMEPOS_RIGHT:
			::SetCursor(LoadCursor(NULL, IDC_SIZEWE));
			break;

		default:
			break;
		}
	}

	CDialog::OnMouseMove(nFlags, point);
}



// NCAgW
int CMainDlg::GetFramePos(CPoint &pt)
{
	CRect rc;
	GetClientRect(&rc);
	rc.DeflateRect(15, 15);// TCYύXE

	int nEx = 0; // ̊gTCY

	if (pt.y < (rc.top + nEx) && pt.x < (rc.left + nEx))
	{
		return FRAMEPOS_TOPLEFT;
	}
	else if (pt.y < (rc.top + nEx) && pt.x > (rc.right - nEx))
	{
		return FRAMEPOS_TOPRIGHT;
	}
	else if (pt.y > (rc.bottom - nEx) && pt.x < (rc.left + nEx))
	{
		return FRAMEPOS_BOTTOMLEFT;
	}
	else if (pt.y > (rc.bottom - nEx) && pt.x > (rc.right - nEx))
	{
		return FRAMEPOS_BOTTOMRIGHT;
	}
	else if (pt.y < rc.top) // ʒu
	{
		return FRAMEPOS_TOP;
	}
	else if (pt.y > rc.bottom)
	{
		return FRAMEPOS_BOTTOM;
	}
	else if (pt.x < rc.left)
	{
		return FRAMEPOS_LEFT;
	}
	else if (pt.x > rc.right)
	{
		return FRAMEPOS_RIGHT;
	}

	return FRAMEPOS_NONE;
}

void CMainDlg::OnWindowSnap()
{
	if (g_cfg.m_bWindowSnap)
	{
		g_cfg.m_bWindowSnap = FALSE;
	}
	else
	{
		g_cfg.m_bWindowSnap = TRUE;
	}
}

void CMainDlg::OnWindowDrag()
{
	if (g_cfg.m_bWindowDrag)
	{
		g_cfg.m_bWindowDrag = FALSE;
	}
	else
	{
		g_cfg.m_bWindowDrag = TRUE;
	}
}

void CMainDlg::OnScreenSaverStop()
{
	if (g_cfg.m_bScreenSaverStop)
	{
		g_cfg.m_bScreenSaverStop = FALSE;
	}
	else
	{
		g_cfg.m_bScreenSaverStop = TRUE;
	}
}

void CMainDlg::OnMonitorPowerOffStop()
{
	if (g_cfg.m_bMonitorPowerOffStop)
	{
		g_cfg.m_bMonitorPowerOffStop = FALSE;
	}
	else
	{
		g_cfg.m_bMonitorPowerOffStop = TRUE;
	}
}

void CMainDlg::OnSystemStanbyStop()
{
	if (g_cfg.m_bSystemStandbyStop)
	{
		g_cfg.m_bSystemStandbyStop = FALSE;
	}
	else
	{
		g_cfg.m_bSystemStandbyStop = TRUE;
	}

	if (g_cfg.m_bSystemStandbyStop && m_Preview.IsRun())
	{
		SetThreadExecutionState(ES_SYSTEM_REQUIRED|ES_CONTINUOUS);
	}

	if (!(g_cfg.m_bSystemStandbyStop) && m_Preview.IsRun())
	{
		SetThreadExecutionState(ES_CONTINUOUS);
	}
}


void CMainDlg::SetAudioVolume(int volume)
{
	try {
		profile_.Preview.nAudioVolume = volume;
		profile_.Preview.bAudioMute = FALSE;
		m_Preview.SetAudioVolume(volume);
		ChangeCaption();
		
	} catch(std::exception const&) {}
}

void CMainDlg::SetAudioVolumeDelta(int volume)
{
	if (m_Preview.IsRun())
	{
		try {

			int master = 0;
			master = profile_.Preview.nAudioVolume;
			master += volume;

			if (volume < 0)
			{
				if (master < 0) { master = 0; }
			}
			else if (volume > 0)
			{
				if (master > 100) { master = 100; }
			}

			profile_.Preview.nAudioVolume = master;
			profile_.Preview.bAudioMute = FALSE;

			m_Preview.SetAudioVolume(master);
			ChangeCaption();
			
		} catch(std::exception const&) {}
	}
}


BOOL CMainDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	if (nFlags & MK_SHIFT)
	{
		if (zDelta < 0) { SetAudioVolumeDelta(-1); }
		else if (zDelta > 0) { SetAudioVolumeDelta(1); }
	}
	else
	{
		if (zDelta < 0) { SetAudioVolumeDelta(-5); }
		else if (zDelta > 0) { SetAudioVolumeDelta(5); }
	}


	return CDialog::OnMouseWheel(nFlags, zDelta, pt);
}

BOOL CMainDlg::ConvertWindowRect(LPRECT lpRect)
{
	if (lpRect == NULL)
	{
		return FALSE;
	}

	CRect rc;
	rc = *lpRect;

	if (g_cfg.m_bTitleBar == TRUE && g_cfg.m_bWindowFrame == TRUE)
	{ // t[/^Cgo[
		int nCYCaption = GetSystemMetrics(SM_CYCAPTION);
		int nCXFrame = GetSystemMetrics(SM_CXFRAME);
		int nCYFrame = GetSystemMetrics(SM_CYFRAME);

		rc.InflateRect(0, nCYCaption, 0, 0);
		rc.InflateRect(nCXFrame, nCYFrame);
	}
	else if (g_cfg.m_bWindowFrame == TRUE)
	{ // t[
		int nCXFrame = GetSystemMetrics(SM_CXFRAME);
		int nCYFrame = GetSystemMetrics(SM_CYFRAME);
		int nCXBorder = GetSystemMetrics(SM_CXBORDER);
		int nCYBorder = GetSystemMetrics(SM_CYBORDER);

		rc.InflateRect(nCXFrame - nCXBorder, nCYFrame - nCYBorder);
	}

	*lpRect = rc;
	return TRUE;
}

BOOL CMainDlg::NoMoveApplyWindowAspectRatioSize(void)
{
	CRect rc;
	GetClientRect(&rc);

	long ax, ay;
	if (m_Preview.ConvertAspectRatio(rc.Width(), rc.Height(), &ax, &ay, FALSE, TRUE) == FALSE)
	{
		return FALSE;
	}

	rc.right = rc.left + ax;
	rc.bottom = rc.top + ay;
	ConvertWindowRect(&rc);

	SetWindowPos(NULL, 0, 0, rc.Width(), rc.Height(), SWP_NOZORDER|SWP_NOMOVE);
	return TRUE;
}

BOOL CMainDlg::SetWindowSize(int nWidth, int nHeight)
{
	CRect rc;
	rc.SetRect(0, 0, nWidth, nHeight);
	ConvertWindowRect(&rc);

	SetWindowPos(NULL, 0, 0, rc.Width(), rc.Height(), SWP_NOMOVE|SWP_NOZORDER);

	if (g_cfg.m_bWindowAspectRatio)
	{
		NoMoveApplyWindowAspectRatioSize();
	}
	return TRUE;
}


// EBhETCY
void CMainDlg::OnSelectWindowSize(UINT nID)
{
	try {
		if (IsZoomed() || m_bFullScreen)
		{
			return;
		}

		WindowSize t = m_vecWindowSize.at(nID - IDM_WINDOWSIZE_RANGE_START);
		SetWindowSize(t.width, t.height);
	} catch(std::exception&) {}
}

void CMainDlg::OnSelectWindowZoom(UINT nID)
{
	try {
		WindowZoom t = m_vecWindowZoom.at(nID - IDM_WINDOWZOOM_RANGE_START);
		SetWindowSizeZoom(static_cast<double>(t.zoom) / 100.0);
	} catch(std::exception&) {}
}

void CMainDlg::OnWindowZoomConfig()
{
	if (m_bFullScreen) { EndMouseHideTimer(); }

	CCommonListDlg dlg;

	dlg.m_vecValue.clear();
	for (auto it = g_cfg.m_vecWindowZoom.begin(); it != g_cfg.m_vecWindowZoom.end(); ++it)
	{
		dlg.m_vecValue.push_back(CommonValue(it->enable, 800, 600, it->zoom));
	}

	dlg.SetMode(CCommonListDlg::WINDOW_ZOOM);
	if (dlg.DoModal() == IDOK)
	{
		g_cfg.m_vecWindowZoom.clear();
		m_vecWindowZoom.clear();
		for (auto it = dlg.m_vecValue.begin(); it != dlg.m_vecValue.end(); ++it)
		{
			g_cfg.m_vecWindowZoom.push_back(WindowZoom(it->enable, it->zoom));
			if (it->enable)
			{
				m_vecWindowZoom.push_back(WindowZoom(it->enable, it->zoom));
			}
		}
	}

	if (m_bFullScreen) { StartMouseHideTimer(); }
}

void CMainDlg::OnWindowSizeConfig()
{
	if (m_bFullScreen)
	{
		EndMouseHideTimer();
	}

	CCommonListDlg dlg;

	dlg.m_vecValue.clear();
	for (std::vector<WindowSize>::iterator it = g_cfg.m_vecWindowSize.begin(), end = g_cfg.m_vecWindowSize.end();
		it != end; ++it)
	{
		dlg.m_vecValue.push_back(CommonValue(it->enable, it->width, it->height, 100));
	}

	dlg.SetMode(CCommonListDlg::WINDOW_SIZE);
	if (dlg.DoModal() == IDOK)
	{
		g_cfg.m_vecWindowSize.clear();
		m_vecWindowSize.clear();
		for (std::vector<CommonValue>::iterator it = dlg.m_vecValue.begin(), end = dlg.m_vecValue.end();
			it != end; ++it)
		{
			g_cfg.m_vecWindowSize.push_back(WindowSize(it->enable, it->width, it->height));
			if (it->enable)
			{
				m_vecWindowSize.push_back(WindowSize(it->enable, it->width, it->height));
			}
		}
	}

	if (m_bFullScreen)
	{
		StartMouseHideTimer();
	}
}



void CMainDlg::OnAspectRatio4_3()
{
	try {
		profile_.Preview.lAspectRatio = ASPECT_RATIO_4_3;
	} catch (std::exception const&) { FAILED_TRACE; }
	m_Preview.SetAspectRatio(4, 3);

	OnPreviewIsRunBuild();
}

void CMainDlg::OnAspectRatio16_9()
{
	try {
		profile_.Preview.lAspectRatio = ASPECT_RATIO_16_9;
	} catch (std::exception const&) { FAILED_TRACE; }
	m_Preview.SetAspectRatio(16, 9);

	OnPreviewIsRunBuild();
}

void CMainDlg::OnAspectRatio10_11()
{
	try {
		profile_.Preview.lAspectRatio = ASPECT_RATIO_10_11;
	} catch (std::exception const&) { FAILED_TRACE; }
	m_Preview.SetAspectRatio(10, 11);

	OnPreviewIsRunBuild();
}

void CMainDlg::OnAspectRatio40_33()
{
	try {
		profile_.Preview.lAspectRatio = ASPECT_RATIO_40_33;
	} catch (std::exception const&) { FAILED_TRACE; }
	m_Preview.SetAspectRatio(40, 33);

	OnPreviewIsRunBuild();
}

void CMainDlg::OnAspectRatioCustom()
{
	if (m_bFullScreen)
	{
		EndMouseHideTimer();
	}

	CAspectRatioDlg dlg;

	try {
		dlg.m_nAspectX = profile_.Preview.nAspectX;
		dlg.m_nAspectY = profile_.Preview.nAspectY;
	} catch (std::exception const&) { FAILED_TRACE; }

	if (dlg.DoModal() == IDOK)
	{
		try {
			profile_.Preview.lAspectRatio = ASPECT_RATIO_CUSTOM;
			profile_.Preview.nAspectX = dlg.m_nAspectX;
			profile_.Preview.nAspectY = dlg.m_nAspectY;
		} catch (std::exception const&) { FAILED_TRACE; }

		m_Preview.SetAspectRatio(dlg.m_nAspectX, dlg.m_nAspectY);

		OnPreviewIsRunBuild();
	}

	if (m_bFullScreen)
	{
		StartMouseHideTimer();
	}
}

void CMainDlg::OnAspectRatioInput()
{
	try {
		profile_.Preview.lAspectRatio = ASPECT_RATIO_INPUT;
	} catch (std::exception const&) { FAILED_TRACE; }
	m_Preview.SetAspectRatio(-1, -1);

	if (g_cfg.m_bWindowAspectRatio && !IsZoomed() && !m_bFullScreen)
	{
		NoMoveApplyWindowAspectRatioSize();
	}

	ResizeWindow();
}

void CMainDlg::OnAspectRatioWindow()
{
	try {
		profile_.Preview.lAspectRatio = ASPECT_RATIO_WINDOW;
	} catch (std::exception const&) { FAILED_TRACE; }
	m_Preview.SetAspectRatio(-2, -2);

	if (g_cfg.m_bWindowAspectRatio && !IsZoomed() && !m_bFullScreen)
	{
		NoMoveApplyWindowAspectRatioSize();
	}

	ResizeWindow();
}



void CMainDlg::OnVideoProcAmp()
{
	ShowInnerFilterDlg(2);
	/*
	if (m_bFullScreen)
	{
		EndMouseHideTimer();
	}

	CVideoProcAmpDlg dlg;

	// ݂̐ݒlǂݍ
	dlg.SetCaptureGraphBuilder(&m_Preview);

	// _CAOJOɃvt@CɌ݂̐ݒlKp
	dlg.GetVideoProcAmpConfig(profile_.VideoProcAmp);

	if (dlg.DoModal() == IDOK)
	{
		// OKŕȂύXlKp
		dlg.GetVideoProcAmpConfig(profile_.VideoProcAmp);
	}

	// vr[ɐݒlKp
	m_Preview.SetVideoProcAmpConfig(profile_.VideoProcAmp);

	if (m_bFullScreen)
	{
		StartMouseHideTimer();
	}
	*/
}


void CMainDlg::OnVmr9ProcAmp()
{
	ShowInnerFilterDlg(3);
	/*
	if (m_bFullScreen) { EndMouseHideTimer(); }

	if (profile_.Preview.lVideoRenderer == VIDEO_RENDERER_VMR9)
	{
		CVMR9ProcAmpDlg dlg;
		dlg.SetCaptureGraphBuilder(&m_Preview);
		if (dlg.DoModal() == IDOK)
		{
			CVMR9ProcAmpConfig cfg;
			dlg.GetConfig(cfg);

			profile_.VMR9ProcAmp = cfg;
		}
		else
		{
			m_Preview.SetVMR9ProcAmp(profile_.VMR9ProcAmp);
		}
	}

	if (m_bFullScreen) { StartMouseHideTimer(); }
	*/
}


void CMainDlg::OnEvrProcAmp()
{
	ShowInnerFilterDlg(4);
/*
	if (m_bFullScreen) { EndMouseHideTimer(); }

	long render = VIDEO_RENDERER_VMR7;
	try {
		render = profile_.Preview.lVideoRenderer;
	} catch (std::exception const&) { FAILED_TRACE; }

	if (render == VIDEO_RENDERER_EVR)
	{
		CEVRProcAmpDlg dlg;
		dlg.SetCaptureGraphBuilder(&m_Preview);
		if (dlg.DoModal() == IDOK)
		{
			CEVRProcAmpConfig cfg;
			dlg.GetConfig(cfg);

			try {
				profile_.EVRProcAmp = cfg;
			} catch (std::exception const&) { FAILED_TRACE; }
		}
		else
		{
			try {
				m_Preview.SetEVRProcAmp(profile_.EVRProcAmp);
			} catch (std::exception const&) { FAILED_TRACE; }
		}
	}

	if (m_bFullScreen)
	{
		StartMouseHideTimer();
	}
*/
}


BOOL CMainDlg::SetWindowSizeZoom(double dZoom)
{
	long cx, cy, ax, ay;
	if (m_Preview.GetNativeVideoSize(&cx, &cy) == FALSE)
	{
		return FALSE;
	}

	if (m_Preview.ConvertAspectRatio(cx, cy, &ax, &ay) == FALSE)
	{
		return FALSE;
	}


	CRect rc;
	rc.SetRect(0, 0, (int)((double)ax * dZoom), (int)((double)ay * dZoom));
	ConvertWindowRect(&rc);

	SetWindowPos(NULL, 0, 0, rc.Width(), rc.Height(), SWP_NOMOVE|SWP_NOZORDER);

	return TRUE;
}

void CMainDlg::OnWindowSizeZoom100X()
{
	SetWindowSizeZoom(1.0);
}


void CMainDlg::OnSizing(UINT fwSide, LPRECT pRect)
{
	CDialog::OnSizing(fwSide, pRect);

	if (g_cfg.m_bWindowAspectRatio == FALSE)
	{
		return;
	}

	if (IsZoomed() || m_bFullScreen)
	{
		return;
	}


	int nCYCaption = GetSystemMetrics(SM_CYCAPTION);
	int nCXFrame = GetSystemMetrics(SM_CXFRAME);
	int nCYFrame = GetSystemMetrics(SM_CYFRAME);
	int nCXBorder = GetSystemMetrics(SM_CXBORDER);
	int nCYBorder = GetSystemMetrics(SM_CYBORDER);


	CRect rc;
	rc = *pRect;
	
	if (g_cfg.m_bTitleBar == TRUE && g_cfg.m_bWindowFrame == TRUE)
	{ // t[/^Cgo[
		rc.DeflateRect(0, nCYCaption, 0, 0);
		rc.DeflateRect(nCXFrame, nCYFrame);
	}
	else if (g_cfg.m_bWindowFrame == TRUE)
	{ // t[
		rc.DeflateRect(nCXFrame - nCXBorder, nCYFrame - nCYBorder);
	}

	long ax = 640, ay = 480;

	switch(fwSide)
	{
	case WMSZ_TOP:
		{
			if (m_Preview.ConvertAspectRatio(rc.Width(), rc.Height(), &ax, &ay, FALSE, TRUE) == FALSE)
			{
				return;
			}
			
			rc.right = rc.left + ax;
			rc.top = rc.bottom - ay;
			break;
		}

	case WMSZ_BOTTOM:
		{
			if (m_Preview.ConvertAspectRatio(rc.Width(), rc.Height(), &ax, &ay, FALSE, TRUE) == FALSE)
			{
				return;
			}
			rc.right = rc.left + ax;
			rc.bottom = rc.top + ay;
			break;
		}

	case WMSZ_LEFT:
		{
			if (m_Preview.ConvertAspectRatio(rc.Width(), rc.Height(), &ax, &ay, FALSE, FALSE) == FALSE)
			{
				return;
			}
			rc.left = rc.right - ax;
			rc.bottom = rc.top + ay;
			break;
		}

	case WMSZ_RIGHT:
		{
			if (m_Preview.ConvertAspectRatio(rc.Width(), rc.Height(), &ax, &ay, FALSE, FALSE) == FALSE)
			{
				return;
			}
			rc.left = rc.right - ax;
			rc.bottom = rc.top + ay;
			break;
		}


	case WMSZ_BOTTOMLEFT:
		{
			if (m_Preview.ConvertAspectRatio(rc.Width(), rc.Height(), &ax, &ay) == FALSE)
			{
				return;
			}
			rc.left = rc.right - ax;
			rc.bottom = rc.top + ay;
			break;
		}

	case WMSZ_TOPRIGHT:
		{
			if (m_Preview.ConvertAspectRatio(rc.Width(), rc.Height(), &ax, &ay) == FALSE)
			{
				return;
			}
			rc.right = rc.left + ax;
			rc.top = rc.bottom - ay;
			break;
		}



	case WMSZ_TOPLEFT:
		{
			if (m_Preview.ConvertAspectRatio(rc.Width(), rc.Height(), &ax, &ay) == FALSE)
			{
				return;
			}
			rc.left = rc.right - ax;
			rc.top = rc.bottom - ay;
			break;
		}

	case WMSZ_BOTTOMRIGHT:
		{
			if (m_Preview.ConvertAspectRatio(rc.Width(), rc.Height(), &ax, &ay) == FALSE)
			{
				return;
			}
			rc.right = rc.left + ax;
			rc.bottom = rc.top + ay;
			break;
		}

	default:
		return;
	}

	if (g_cfg.m_bTitleBar == TRUE && g_cfg.m_bWindowFrame == TRUE)
	{ // t[/^Cgo[
		rc.InflateRect(0, nCYCaption, 0, 0);
		rc.InflateRect(nCXFrame, nCYFrame);
	}
	else if (g_cfg.m_bWindowFrame == TRUE)
	{ // t[
		rc.InflateRect(nCXFrame - nCXBorder, nCYFrame - nCYBorder);
	}

	*pRect = rc;
}

void CMainDlg::OnWindowAspectRatio()
{
	g_cfg.m_bWindowAspectRatio = g_cfg.m_bWindowAspectRatio ? FALSE : TRUE;

	if (g_cfg.m_bWindowAspectRatio && !IsZoomed() && !m_bFullScreen)
	{
		NoMoveApplyWindowAspectRatioSize();
	}
}

void CMainDlg::OnAudioVolume100()
{
	SetAudioVolume(100);
}

void CMainDlg::OnAudioVolume90()
{
	SetAudioVolume(90);
}

void CMainDlg::OnAudioVolume80()
{
	SetAudioVolume(80);
}

void CMainDlg::OnAudioVolume70()
{
	SetAudioVolume(70);
}

void CMainDlg::OnAudioVolume60()
{
	SetAudioVolume(60);
}

void CMainDlg::OnAudioVolume50()
{
	SetAudioVolume(50);
}

void CMainDlg::OnAudioVolume40()
{
	SetAudioVolume(40);
}

void CMainDlg::OnAudioVolume30()
{
	SetAudioVolume(30);
}

void CMainDlg::OnAudioVolume20()
{
	SetAudioVolume(20);
}

void CMainDlg::OnAudioVolume10()
{
	SetAudioVolume(10);
}

void CMainDlg::OnAudioVolume0()
{
	SetAudioVolume(0);
}


void CMainDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID == SC_SCREENSAVE)
	{
		if (g_cfg.m_bScreenSaverStop && m_Preview.IsRun())
		{
			return;
		}
	}

	if (nID == SC_MONITORPOWER)
	{
		if (g_cfg.m_bMonitorPowerOffStop && m_Preview.IsRun())
		{
			return;
		}
	}

	CDialog::OnSysCommand(nID, lParam);
}


void CMainDlg::OnCropping()
{
	ShowInnerFilterDlg(1);

	/*
	if (m_bFullScreen)
	{
		EndMouseHideTimer();
	}

	CCroppingDlg dlg;

	RECT rc = {0, 0, 0, 0};

	try {
		rc = profile_.Preview.rcCropping;
		dlg.SetCroppingRect(rc);
		dlg.SetCaptureGraphBuilder(&m_Preview);
	} catch(std::exception const&) {}

	dlg.m_vecCrop = g_cfg.m_vecCrop;

	if (dlg.DoModal() == IDOK)
	{
		g_cfg.m_vecCrop = dlg.m_vecCrop;

		try {
			dlg.GetCroppingRect(rc);
			profile_.Preview.rcCropping = rc;
		} catch(std::exception const&) {}
	}

	m_Preview.SetCroppingRect(rc);
	m_Preview.SetVideoPosition();

	if (m_bFullScreen)
	{
		StartMouseHideTimer();
	}
	*/
}

void CMainDlg::OnVersion()
{
	if (m_bFullScreen)
	{
		EndMouseHideTimer();
	}

	CVersionDlg dlg;

	if (dlg.DoModal() == IDOK)
	{
	
	}

	if (m_bFullScreen)
	{
		StartMouseHideTimer();
	}
}

LRESULT CMainDlg::OnDisplayChange(WPARAM wParam, LPARAM lParam)
{
	/*
    BYTE byDepth    = (BYTE)wParam;             // F
    WORD wScrWidth  = (WORD)LOWORD(lParam);     // ʉsNZ
    WORD wScrHeight = (WORD)HIWORD(lParam);     // ʏcsNZ
	*/

	m_Preview.DisplayModeChanged();


	return CDialog::OnDisplayChange(wParam, lParam);
}

void CMainDlg::OnClose()
{
	OnPreviewStop();
	m_Preview.UnInit();

	CDialog::OnClose();
}

void CMainDlg::OnSnapshot()
{
	if (!(m_Preview.IsRun()))
	{
		return;
	}

	BITMAPINFO BmpInfo;
	LPBYTE pDIB = NULL;
	if (m_Preview.GetCurrentImage(&BmpInfo, &pDIB))
	{
		long lWidth = 0, lHeight = 0;
		long lAspextCX = 0, lAspectCY = 0;
		RECT rcCrop;
		SetRect(&rcCrop, 0, 0, 0, 0);

		if (g_cfg.m_nSnapShotVideoSize == 1)
		{
			// ̓TCY\AXyNg
			m_Preview.GetNativeVideoSize(&lWidth, &lHeight);
			m_Preview.ConvertAspectRatio(lWidth, lHeight, &lAspextCX, &lAspectCY);
		}
		else if (g_cfg.m_nSnapShotVideoSize == 2)
		{
			// \TCY
			CRect rcClient;
			GetClientRect(&rcClient);
			m_Preview.ConvertAspectRatio(rcClient.Width(), rcClient.Height(), &lAspextCX, &lAspectCY);
		}
		else
		{
			// ̓TCY
			m_Preview.GetNativeVideoSize(&lAspextCX, &lAspectCY);
		}

		if (g_cfg.m_bSnapShotCrop)
		{
			// NbvKp
			try {
				rcCrop = profile_.Preview.rcCropping;
			} catch (std::exception const&) {}
		}

		CSnapShot snap;
		snap.Save(
			g_cfg.m_wsSnapShotFolder.c_str(),
			g_cfg.m_lSnapShotType,
			&BmpInfo, pDIB,
			lAspextCX, lAspectCY,
			&rcCrop,
			g_cfg.m_nSnapShotJpegQuality);
		

		if (pDIB)
		{
			delete [] pDIB;
		}

	}
}

void CMainDlg::OnSnapshotConfig()
{
	if (m_bFullScreen)
	{
		EndMouseHideTimer();
	}

	CSnapShotDlg dlg;
	dlg.m_wsSnapShotFolder = g_cfg.m_wsSnapShotFolder;
	dlg.m_lSnapShotType = g_cfg.m_lSnapShotType;
	dlg.m_nSnapShotVideoSize = g_cfg.m_nSnapShotVideoSize;
	dlg.m_bSnapShotCrop = g_cfg.m_bSnapShotCrop;
	dlg.m_nSnapShotJpegQuality = g_cfg.m_nSnapShotJpegQuality;

	if (dlg.DoModal() == IDOK)
	{
		g_cfg.m_wsSnapShotFolder = dlg.m_wsSnapShotFolder;
		g_cfg.m_lSnapShotType = dlg.m_lSnapShotType;
		g_cfg.m_nSnapShotVideoSize = dlg.m_nSnapShotVideoSize;
		g_cfg.m_bSnapShotCrop = dlg.m_bSnapShotCrop;
		g_cfg.m_nSnapShotJpegQuality = dlg.m_nSnapShotJpegQuality;

		if (g_cfg.m_wsSnapShotFolder == L"")
		{
			g_cfg.m_wsSnapShotFolder = g_cfg.m_wsCurrentFolder;
		}
	}

	if (m_bFullScreen)
	{
		StartMouseHideTimer();
	}
}

void CMainDlg::OnSnapshotFolder()
{
	if (IsZoomed() || m_bFullScreen)
	{
		return;
	}
	::ShellExecute(NULL, L"open", g_cfg.m_wsSnapShotFolder.c_str(), NULL, NULL, SW_SHOWNORMAL);
}





void CMainDlg::OnKeyConfig()
{
	if (m_bFullScreen) { EndMouseHideTimer(); }

	CShortCutDlg dlg;
	dlg.SetShortCut(g_cfg.m_vecShortCut);
	if (dlg.DoModal() == IDOK)
	{
		dlg.GetShortCut(g_cfg.m_vecShortCut);
	}

	if (m_bFullScreen) { StartMouseHideTimer(); }
}



void CMainDlg::OnDeinterlace()
{
	ShowInnerFilterDlg(6);
}



void CMainDlg::OnAudioVolumeUp5()
{
	SetAudioVolumeDelta(5);
}


void CMainDlg::OnAudioVolumeDown5()
{
	SetAudioVolumeDelta(-5);
}

void CMainDlg::OnAudioVolumeUp1()
{
	SetAudioVolumeDelta(1);
}


void CMainDlg::OnAudioVolumeDown1()
{
	SetAudioVolumeDelta(-1);
}


void CMainDlg::OnAudioVolumeUp10()
{
	SetAudioVolumeDelta(10);
}


void CMainDlg::OnAudioVolumeDown10()
{
	SetAudioVolumeDelta(-10);
}


void CMainDlg::OnMove(int x, int y)
{
	//CDialog::OnMove(x, y);
	if (IsWindowVisible() && !IsZoomed() && !m_bFullScreen && g_cfg.m_bWindowSnap)
	{
		RECT rc;
		GetWindowRect(&rc);
		CPoint pt(rc.left, rc.top);
		setWindowSnap(GetSafeHwnd(), &pt);
	}
}



void CMainDlg::OnAudioMute()
{
	if (profile_.Preview.bAudioMute)
	{
		profile_.Preview.bAudioMute = FALSE;
		SetAudioVolume(profile_.Preview.nAudioVolume);
	}
	else
	{
		profile_.Preview.bAudioMute = TRUE;
		m_Preview.SetAudioVolume(0);
		ChangeCaption();
	}
}


void CMainDlg::OnMButtonDown(UINT nFlags, CPoint point)
{
	OnAudioMute();

	CDialog::OnMButtonDown(nFlags, point);
}
