#pragma once

#include <Dwmapi.h>

BOOL GetDesktopRectFromPoint(const POINT pt, RECT &rc);
BOOL GetDesktopRectFromRect(const RECT &rcFrom, RECT &rc);
BOOL GetDesktopRectFromWindow(const HWND hWnd, RECT &rc);

////////////////////////////////////////
// fXNgbv֐
BOOL getDesktopRectFromPoint(const POINT pt, MONITORINFO &mi);
BOOL getDesktopRectFromRect(const RECT &rcFrom, MONITORINFO &mi);
BOOL getDesktopRectFromWindow(const HWND hWnd, MONITORINFO &mi);

////////////////////////////////////////
// EBhEXibv
void setWindowSnap(HWND hwnd, LPPOINT lppt, int distance = 10);




class ModuleLoader {
	static HMODULE module_;

	typedef HRESULT (WINAPI* PDwmIsCompositionEnabled)(BOOL*);
	typedef HRESULT (WINAPI* PDwmGetWindowAttribute)(HWND, DWORD, LPCVOID, DWORD);

	static PDwmIsCompositionEnabled fpDwmIsCompositionEnabled;
	static PDwmGetWindowAttribute fpDwmGetWindowAttribute;

	ModuleLoader();
	~ModuleLoader();

public:
	static void Init();

	static HRESULT WINAPI DwmIsCompositionEnabled(_Out_ BOOL *pfEnabled);
	static HRESULT WINAPI DwmGetWindowAttribute(HWND hwnd, DWORD dwAttribute, _Out_ PVOID pvAttribute, DWORD cbAttribute);
};

BOOL GetWindowShapeRect(HWND hwnd, LPRECT lprc);
