#pragma once

#include "afxcmn.h"
#include "afxwin.h"

#include "CaptureFilterInfo.h"
#include "ProfileVideoDlg.h"
#include "ProfileAudioDlg.h"
#include "ProfileFilterDlg.h"
#include "ProfilePreviewDlg.h"


// CProfileMainDlg _CAO

class CProfileMainDlg : public CDialog
{
	DECLARE_DYNAMIC(CProfileMainDlg)

public:
	CProfileMainDlg(CWnd* pParent = NULL);   // WRXgN^
	virtual ~CProfileMainDlg();

// _CAO f[^
	enum { IDD = IDD_PROFILE_MAIN };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	CTabCtrl m_xcTab;
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	BOOL InitChildDlg(void);
	BOOL InitTab();
	BOOL InitSize();
	BOOL InitControl();
	BOOL InitProfile();

	afx_msg void OnTcnSelchangeTab(NMHDR *pNMHDR, LRESULT *pResult);


	int m_nLastTab; // ŌɑIꂽ^u
	int m_nSelected; // I𒆃vt@Cԍ
	BOOL m_bPreview; // OKŕƂIvt@CĐ

	// vt@Cݒ
	BOOL Init(int nSelected, std::vector<CCaptureGraphProfile> &vecProfile);
	
	std::vector<CCaptureGraphProfile> m_vecProfile; // vt@C

	CProfileVideoDlg m_dlgVideo;
	CProfileAudioDlg m_dlgAudio;
	CProfileFilterDlg m_dlgFilter;
	//CProfilePreviewDlg m_dlgPreview;
	

	CComboBox m_xcCmbProfile;
	CEdit m_xcEditProfile;
	CButton m_xcCheck;

	afx_msg void OnCbnSelchangeCmbProfile();
	afx_msg void OnEnChangeEditProfile();
protected:
	virtual void OnOK();
public:
	afx_msg void OnBnClickedBtnProfile();
	afx_msg void OnBnClickedCheck();
};
