// ProfilePreviewDlg.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "ProfilePreviewDlg.h"


// CProfilePreviewDlg _CAO

IMPLEMENT_DYNAMIC(CProfilePreviewDlg, CDialog)

CProfilePreviewDlg::CProfilePreviewDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProfilePreviewDlg::IDD, pParent)
	, m_xvRadioVideo(0)
	, m_xvRadioAudio(0)
{

}

CProfilePreviewDlg::~CProfilePreviewDlg()
{
}

void CProfilePreviewDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_RADIO_VIDEO_PREVIEW_PIN, m_xvRadioVideo);
	DDX_Radio(pDX, IDC_RADIO_AUDIO_PREVIEW_PIN, m_xvRadioAudio);
}


BEGIN_MESSAGE_MAP(CProfilePreviewDlg, CDialog)
END_MESSAGE_MAP()


// CProfilePreviewDlg bZ[W nh

BOOL CProfilePreviewDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CProfilePreviewDlg::SetProfile(CPreviewConfig &profile)
{
	m_xvRadioVideo = profile.bVideoPreviewPin ? 0 : 1;
	m_xvRadioAudio = profile.bAudioPreviewPin ? 0 : 1;
	UpdateData(FALSE);
}

void CProfilePreviewDlg::GetProfile(CPreviewConfig &profile)
{
	UpdateData();
	profile.bVideoPreviewPin = m_xvRadioVideo == 0 ? TRUE : FALSE;
	profile.bAudioPreviewPin = m_xvRadioAudio == 0 ? TRUE : FALSE;
}

