#pragma once
#include "afxwin.h"


// CRotationPage _CAO

class CRotationPage : public CPropertyPage
{
	DECLARE_DYNAMIC(CRotationPage)

public:
	CRotationPage(CMainDlg *dlg, CCaptureGraphProfile *profile);
	virtual ~CRotationPage();

// _CAO f[^
	enum { IDD = IDD_ROTATION };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()

private:
	CMainDlg* const dlg_;
	CCaptureGraphProfile* const profile_;
	BOOL enableCtrl_;

public:
	virtual BOOL OnInitDialog();
	virtual void OnOK();

	CComboBox m_xcCmbRotation;
	CButton m_xcCbDoubleHeight;
	CButton m_xcCbFlipHorizontal;
	CButton m_xcCbFlipVertical;

	afx_msg void OnCbnSelchangeCmbRotation();
	afx_msg void OnBnClickedCbDoubleHeight();
	afx_msg void OnBnClickedCbFlipHorizontal();
	afx_msg void OnBnClickedCbFlipVertical();

	void EnableCtrl(BOOL enable);
};
