// ShortCutDlg.cpp : t@C
//

#include "stdafx.h"
#include "PeCaTV2.h"
#include "ShortCutDlg.h"
#include "afxdialogex.h"


// CShortCutDlg _CAO

IMPLEMENT_DYNAMIC(CShortCutDlg, CDialog)

CShortCutDlg::CShortCutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CShortCutDlg::IDD, pParent)
{

}

CShortCutDlg::~CShortCutDlg()
{
}

void CShortCutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_xcList);
	DDX_Control(pDX, IDC_ED_KEY, m_xcEdKey);
	DDX_Control(pDX, IDC_CB_KEY_SHIFT, m_xcCbKeyShift);
	DDX_Control(pDX, IDC_CB_KEY_CTRL, m_xcCbKeyCtrl);
	DDX_Control(pDX, IDC_CB_KEY_ALT, m_xcCbKeyAlt);
	DDX_Control(pDX, IDC_BTN_KEY_CLEAR, m_xcBtnKeyClear);
	//DDX_Control(pDX, IDC_CMB_MOUSE, m_xcCmbMouse);
	//DDX_Control(pDX, IDC_CB_MOUSE_SHIFT, m_xcCbMouseShift);
	//DDX_Control(pDX, IDC_CB_MOUSE_CTRL, m_xcCbMouseCtrl);
	//DDX_Control(pDX, IDC_CB_MOUSE_ALT, m_xcCbMouseAlt);
	//DDX_Control(pDX, IDC_BTN_MOUSE_CLEAR, m_xcBtnMouseClear);
}


BEGIN_MESSAGE_MAP(CShortCutDlg, CDialog)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST, &CShortCutDlg::OnLvnGetdispinfoList)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST, &CShortCutDlg::OnLvnItemchangedList)
	ON_BN_CLICKED(IDC_CB_KEY_SHIFT, &CShortCutDlg::OnBnClickedCbKeyShift)
	ON_BN_CLICKED(IDC_CB_KEY_CTRL, &CShortCutDlg::OnBnClickedCbKeyCtrl)
	ON_BN_CLICKED(IDC_CB_KEY_ALT, &CShortCutDlg::OnBnClickedCbKeyAlt)
	ON_BN_CLICKED(IDC_BTN_KEY_CLEAR, &CShortCutDlg::OnBnClickedBtnKeyClear)
	//ON_CBN_SELCHANGE(IDC_CMB_MOUSE, &CShortCutDlg::OnCbnSelchangeCmbMouse)
	//ON_BN_CLICKED(IDC_CB_MOUSE_SHIFT, &CShortCutDlg::OnBnClickedCbMouseShift)
	//ON_BN_CLICKED(IDC_CB_MOUSE_CTRL, &CShortCutDlg::OnBnClickedCbMouseCtrl)
	//ON_BN_CLICKED(IDC_CB_MOUSE_ALT, &CShortCutDlg::OnBnClickedCbMouseAlt)
	//ON_BN_CLICKED(IDC_BTN_MOUSE_CLEAR, &CShortCutDlg::OnBnClickedBtnMouseClear)
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CShortCutDlg::OnBnClickedBtnAllDefault)
	ON_BN_CLICKED(IDC_BTN_ALL_CLEAR, &CShortCutDlg::OnBnClickedBtnAllClear)
	ON_WM_CTLCOLOR()
	ON_EN_SETFOCUS(IDC_ED_KEY, &CShortCutDlg::OnEnSetfocusEdKey)
	ON_EN_KILLFOCUS(IDC_ED_KEY, &CShortCutDlg::OnEnKillfocusEdKey)
END_MESSAGE_MAP()

void CShortCutDlg::GetShortCut(std::vector<ShortCut>& data)
{
	data = data_;
}

void CShortCutDlg::SetShortCut(const std::vector<ShortCut>& data)
{
	// 炩ߏݒɂ
	InitShortCut(data_);

	for (auto it1 = data.begin(); it1 != data.end(); ++it1)
	{
		for (auto it2 = data_.begin(); it2 != data_.end(); ++it2)
		{
			if (it1->dwMessageID == it2->dwMessageID)
			{// bZ[WID̂ŃL[R[h㏑
				*it2 = *it1;
			}
		}
	}
}

void CShortCutDlg::EnableControls(BOOL enable)
{
	m_xcEdKey.EnableWindow(enable);
	m_xcCbKeyShift.EnableWindow(enable);
	m_xcCbKeyCtrl.EnableWindow(enable);
	m_xcCbKeyAlt.EnableWindow(enable);
	m_xcBtnKeyClear.EnableWindow(enable);

	//m_xcCmbMouse.EnableWindow(enable);
	//m_xcCbMouseShift.EnableWindow(enable);
	//m_xcCbMouseCtrl.EnableWindow(enable);
	//m_xcCbMouseAlt.EnableWindow(enable);
	//m_xcBtnMouseClear.EnableWindow(enable);
}

// Rg[ɏ𔽉f
// CfbNX͈͊OȂRg[𖳌ɂ
void CShortCutDlg::SettingControls(int index)
{
	if (index < 0)
	{
		EnableControls(FALSE);

		m_xcEdKey.SetWindowText(L"");
		m_xcCbKeyShift.SetCheck(BST_UNCHECKED);
		m_xcCbKeyCtrl.SetCheck(BST_UNCHECKED);
		m_xcCbKeyAlt.SetCheck(BST_UNCHECKED);

		//m_xcCmbMouse.SetCurSel(0);
		//m_xcCbMouseShift.SetCheck(BST_UNCHECKED);
		//m_xcCbMouseCtrl.SetCheck(BST_UNCHECKED);
		//m_xcCbMouseAlt.SetCheck(BST_UNCHECKED);
	}
	else if (index < static_cast<int>(data_.size()))
	{
		try {
			ShortCut data = data_.at(index);
			DWORD mod;

			EnableControls(TRUE);

			SettingKeyCapture(data.dwKeyModify, data.dwKeyCode);

			mod = data.dwKeyModify;
			m_xcCbKeyShift.SetCheck((mod & MODIFY_CODE_SHIFT) ? BST_CHECKED : BST_UNCHECKED);
			m_xcCbKeyCtrl.SetCheck((mod & MODIFY_CODE_CTRL) ? BST_CHECKED : BST_UNCHECKED);
			m_xcCbKeyAlt.SetCheck((mod & MODIFY_CODE_ALT) ? BST_CHECKED : BST_UNCHECKED);

			//m_xcCmbMouse.SetCurSel(data.dwMouseCode);
			//mod = data.dwMouseModify;
			//m_xcCbMouseShift.SetCheck((mod & MODIFY_CODE_SHIFT) ? BST_CHECKED : BST_UNCHECKED);
			//m_xcCbMouseCtrl.SetCheck((mod & MODIFY_CODE_CTRL) ? BST_CHECKED : BST_UNCHECKED);
			//m_xcCbMouseAlt.SetCheck((mod & MODIFY_CODE_ALT) ? BST_CHECKED : BST_UNCHECKED);
		}
		catch (std::exception const&) {}
	}
}

void CShortCutDlg::SettingKeyCapture(DWORD modify, DWORD code)
{
	if (modify != 0 && code != 0)
	{
		std::wstring mod = GetModifyCodeName(modify);
		std::wstring key = GetKeyCodeName(code);
		m_xcEdKey.SetWindowText((mod + L" + " + key).c_str());
	}
	else
	{
		m_xcEdKey.SetWindowText(GetKeyCodeName(code).c_str());
	}
}

// CShortCutDlg bZ[W nh[

void CShortCutDlg::InitializeData()
{
	InitShortCut(data_);
}


BOOL CShortCutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// GfBbgRg[wiF
	color_ = RGB(255, 255, 255);
	brush_.CreateSolidBrush(color_);

	
	// XgRg[
	m_xcList.SetExtendedStyle(m_xcList.GetExtendedStyle()|
		LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_INFOTIP);

	m_xcList.InsertColumn(0, L"R}h", LVCFMT_LEFT, 300);
	m_xcList.InsertColumn(1, L"L[", LVCFMT_CENTER, 200);
	//m_xcList.InsertColumn(2, L"}EX", LVCFMT_CENTER, 150);

	m_xcList.SetItemCountEx(static_cast<int>(data_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	// }EX
	// R{{bNX
	/*
	for (DWORD i = 0; i < MOUSE_CODE_END; ++i)
	{
		m_xcCmbMouse.AddString(GetMouseCodeName(i).c_str());
	}
	*/


	SettingControls(-1);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CShortCutDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN ||
		pMsg->message == WM_SYSKEYDOWN)
	{
		CWnd *wnd = GetFocus(); // tH[JXGfBbg{bNXɂ
		if (wnd && m_xcEdKey == *wnd)
		{
			if (pMsg->wParam == VK_SHIFT ||
				pMsg->wParam == VK_CONTROL ||
				pMsg->wParam == VK_MENU) // ALT
			{
				return TRUE;
			}
			else
			{
				int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
				DWORD shift = (GetAsyncKeyState(VK_SHIFT) & 0x8000) ? MODIFY_CODE_SHIFT : 0;
				DWORD ctrl = (GetAsyncKeyState(VK_CONTROL) & 0x8000) ? MODIFY_CODE_CTRL : 0;
				DWORD alt = (GetAsyncKeyState(VK_MENU) & 0x8000) ? MODIFY_CODE_ALT : 0;
				DWORD modify = shift | ctrl | alt;
				DWORD code = static_cast<DWORD>(pMsg->wParam);


				try {
					DeleteKeyCode(data_, modify, code);

					data_.at(index).dwKeyModify = modify;
					data_.at(index).dwKeyCode = code;

					SettingKeyCapture(modify, code);
					
					m_xcCbKeyShift.SetCheck(shift ? BST_CHECKED : BST_UNCHECKED);
					m_xcCbKeyCtrl.SetCheck(ctrl ? BST_CHECKED : BST_UNCHECKED);
					m_xcCbKeyAlt.SetCheck(alt ? BST_CHECKED : BST_UNCHECKED);

					m_xcList.RedrawWindow();

					return TRUE;
				}
				catch (std::exception const&) {}
			}
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}


void CShortCutDlg::OnLvnGetdispinfoList(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);
	if (pDispInfo == NULL) { return; }

	ShortCut data;

	try {
		data = data_.at(pDispInfo->item.iItem);
	}
	catch (std::exception const&) {
		if (pResult) { *pResult = 0; }
		return;
	}

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString tmp;
		switch (pDispInfo->item.iSubItem)
		{
		case 0:
			{
				tmp = GetMessageIDName(data.dwMessageID).c_str();
				break;
			}
		case 1:
			{
				if (data.dwKeyModify != 0 && data.dwKeyCode != 0)
				{
					std::wstring mod = GetModifyCodeName(data.dwKeyModify);
					std::wstring key = GetKeyCodeName(data.dwKeyCode);
					tmp = (mod + L" + " + key).c_str();
				}
				else if (data.dwKeyCode != 0)
				{
					tmp = GetKeyCodeName(data.dwKeyCode).c_str();
				}
				break;
			}
			/*
		case 2:
			{
				if (data.dwMouseModify != 0 && data.dwMouseCode != 0)
				{
					std::wstring mod = GetModifyCodeName(data.dwMouseModify);
					std::wstring mouse = GetMouseCodeName(data.dwMouseCode);
					tmp = (mod + L" + " + mouse).c_str();
				}
				else if (data.dwMouseCode != 0)
				{
					tmp = GetMouseCodeName(data.dwMouseCode).c_str();
				}
				break;
			}
			*/
		}

		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			tmp, _TRUNCATE);
	}

	if (pResult) { *pResult = 0; }
}



void CShortCutDlg::OnLvnItemchangedList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	SettingControls(m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED));

	*pResult = 0;
}

void CShortCutDlg::SettingKeyModify(int index)
{
	try {
		DWORD shift = m_xcCbKeyShift.GetCheck() == BST_CHECKED ? MODIFY_CODE_SHIFT : MODIFY_CODE_NONE;
		DWORD ctrl = m_xcCbKeyCtrl.GetCheck() == BST_CHECKED ? MODIFY_CODE_CTRL : MODIFY_CODE_NONE;
		DWORD alt = m_xcCbKeyAlt.GetCheck() == BST_CHECKED ? MODIFY_CODE_ALT : MODIFY_CODE_NONE;

		DWORD modify = shift | ctrl | alt;
		DWORD code = data_.at(index).dwKeyCode;

		DeleteKeyCode(data_, modify, code);

		data_.at(index).dwKeyModify = modify;

		SettingKeyCapture(modify, code);

		m_xcList.RedrawItems(index, index);
	}
	catch (std::exception const&) {}
}

void CShortCutDlg::OnBnClickedCbKeyShift()
{
	SettingKeyModify(m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED));
}

void CShortCutDlg::OnBnClickedCbKeyCtrl()
{
	SettingKeyModify(m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED));
}

void CShortCutDlg::OnBnClickedCbKeyAlt()
{
	SettingKeyModify(m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED));
}

void CShortCutDlg::OnBnClickedBtnKeyClear()
{
	int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);

	try {
		data_.at(index).dwKeyModify = 0;
		data_.at(index).dwKeyCode = 0;
		m_xcEdKey.SetWindowText(GetKeyCodeName(0).c_str());
		m_xcCbKeyShift.SetCheck(BST_UNCHECKED);
		m_xcCbKeyCtrl.SetCheck(BST_UNCHECKED);
		m_xcCbKeyAlt.SetCheck(BST_UNCHECKED);
		m_xcList.RedrawItems(index, index);
	}
	catch (std::exception const&) {}
}

/*
void CShortCutDlg::OnCbnSelchangeCmbMouse()
{
	int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	int sel = m_xcCmbMouse.GetCurSel();

	try {
		DWORD modify = data_.at(index).dwMouseModify;
		DWORD code = sel;

		DeleteMouseCode(data_, modify, code);

		data_.at(index).dwMouseCode = code;
		m_xcList.RedrawWindow();
	}
	catch (std::exception const&) {}
}

void CShortCutDlg::SettingMouseModify(int index)
{
	try {
		DWORD shift = m_xcCbMouseShift.GetCheck() == BST_CHECKED ? MODIFY_CODE_SHIFT : MODIFY_CODE_NONE;
		DWORD ctrl = m_xcCbMouseCtrl.GetCheck() == BST_CHECKED ? MODIFY_CODE_CTRL : MODIFY_CODE_NONE;
		DWORD alt = m_xcCbMouseAlt.GetCheck() == BST_CHECKED ? MODIFY_CODE_ALT : MODIFY_CODE_NONE;

		DWORD modify = shift | ctrl | alt;
		DWORD code = data_.at(index).dwMouseCode;

		DeleteMouseCode(data_, modify, code);

		data_.at(index).dwMouseModify = modify;
		m_xcList.RedrawWindow();
	}
	catch (std::exception const&) {}
}

void CShortCutDlg::OnBnClickedCbMouseShift()
{
	SettingMouseModify(m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED));
}


void CShortCutDlg::OnBnClickedCbMouseCtrl()
{
	SettingMouseModify(m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED));
}

void CShortCutDlg::OnBnClickedCbMouseAlt()
{
	SettingMouseModify(m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED));
}

void CShortCutDlg::OnBnClickedBtnMouseClear()
{
	int index = m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);

	try {
		data_.at(index).dwMouseModify = 0;
		data_.at(index).dwMouseCode = 0;
		m_xcCmbMouse.SetCurSel(0);
		m_xcCbMouseShift.SetCheck(BST_UNCHECKED);
		m_xcCbMouseCtrl.SetCheck(BST_UNCHECKED);
		m_xcCbMouseAlt.SetCheck(BST_UNCHECKED);
		m_xcList.RedrawItems(index, index);
	}
	catch (std::exception const&) {}
}
*/

void CShortCutDlg::OnBnClickedBtnAllDefault()
{
	m_xcList.SetItemCountEx(0, LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	InitializeData();

	m_xcList.SetItemCountEx(static_cast<int>(data_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);
	m_xcList.RedrawWindow();
}


void CShortCutDlg::OnBnClickedBtnAllClear()
{
	DWORD id;
	std::vector<ShortCut>::iterator it = data_.begin(), end = data_.end();
	for (; it != end; ++it)
	{
		id = it->dwMessageID;
		*it = ShortCut();
		it->dwMessageID = id;
	}
	SettingControls(m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED));
	m_xcList.RedrawWindow();
}

HBRUSH CShortCutDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	switch(nCtlColor)
	{	
	case CTLCOLOR_EDIT:
		// GfBbg{bNX
		if (GetDlgItem(pWnd->GetDlgCtrlID())->GetSafeHwnd() == m_xcEdKey.GetSafeHwnd())
		{
			pDC->SetBkMode(OPAQUE);
			pDC->SetBkColor(color_);
			pDC->SetTextColor(RGB(0, 0, 0));			
			return reinterpret_cast<HBRUSH>(brush_.GetSafeHandle());
		}
		else
		{
			return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);	
		}

	default:
		return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	}
	return hbr;
}

void CShortCutDlg::OnEnSetfocusEdKey()
{
	::DestroyCaret();

	color_ = RGB(0xFF, 0xFF, 0x55);
	brush_.DeleteObject();
	brush_.CreateSolidBrush(color_);
	m_xcEdKey.SetWindowText(L"ݒ肷L[Ă");
}

void CShortCutDlg::OnEnKillfocusEdKey()
{
	color_ = RGB(255, 255, 255);
	brush_.DeleteObject();
	brush_.CreateSolidBrush(color_);

	try {
		DWORD code = data_.at(m_xcList.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED)).dwKeyCode;
		m_xcEdKey.SetWindowText(GetKeyCodeName(code).c_str());
	}
	catch(std::exception const&) {}
}
