#pragma once

class CSnapShot
{
public:
	CSnapShot(void);
	CSnapShot(BITMAPINFO *pBmpInfo, BYTE *pDIB);
	~CSnapShot(void);

	BOOL Save(LPCWSTR pwszFolderPath, long lFormat, BITMAPINFO *pBmpInfo, BYTE *pDIB, int nWidth, int nHeight, LPRECT prcCrop, ULONG ulJpegQuality);


enum {
	FORMAT_BMP,
	FORMAT_JPG,
	FORMAT_PNG,
};


private:
	void CreateFileName(long lFormat, std::wstring &wsFileName);
	BOOL GetEncoderClsid(const WCHAR* format, CLSID* pClsid);
	BOOL GetEncoderClsid(long lFormat, CLSID* pClsid);
};
