#pragma once

#include "CaptureGraphBuilder.h"
#include "afxwin.h"

// CVideoProcAmpPage _CAO

class CVideoProcAmpPage : public CPropertyPage
{
	DECLARE_DYNAMIC(CVideoProcAmpPage)

public:
	CVideoProcAmpPage(CMainDlg *dlg, CCaptureGraphProfile *profile);
	virtual ~CVideoProcAmpPage();

// _CAO f[^
	enum { IDD = IDD_VIDEO_PROC_AMP };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()

private:
	CMainDlg* const dlg_;
	CCaptureGraphProfile* const profile_;

public:
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);

private:
	CCaptureGraphBuilder* const graph_;
	CVideoProcAmp range_[10];
	CVideoProcAmpConfig* const cfg_;

private:
	void OnAutoCheck(int i);
	void OnDefault(int i);

	CScrollBar m_xcSBCtrl[10];
	CButton m_xcCBCtrl[10];
	CButton m_xcBTCtrl[10];
	CEdit m_xcEBCtrl[10];
	CButton m_xcBTDefault;

public:
	afx_msg void OnBnClickedCbBrightness();
	afx_msg void OnBnClickedCbContrast();
	afx_msg void OnBnClickedCbHue();
	afx_msg void OnBnClickedCbSaturation();
	afx_msg void OnBnClickedCbSharpness();
	afx_msg void OnBnClickedCbGamma();
	afx_msg void OnBnClickedCbColorEnable();
	afx_msg void OnBnClickedCbWhiteBalance();
	afx_msg void OnBnClickedCbBacklightCompensation();
	afx_msg void OnBnClickedCbGain();
	afx_msg void OnBnClickedBtBrightness();
	afx_msg void OnBnClickedBtContrast();
	afx_msg void OnBnClickedBtHue();
	afx_msg void OnBnClickedBtSaturation();
	afx_msg void OnBnClickedBtSharpness();
	afx_msg void OnBnClickedBtGamma();
	afx_msg void OnBnClickedBtColorEnable();
	afx_msg void OnBnClickedBtWhiteBalance();
	afx_msg void OnBnClickedBtBacklightCompensation();
	afx_msg void OnBnClickedBtGain();
	afx_msg void OnBnClickedBtDefault();
};
